
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Texte_Accueil_Ligne0=R4
	.DEF _Texte_Accueil_Ligne1=R6
	.DEF _TexteMenuCoefMot=R8
	.DEF _TexteMenuActiveRobot=R10
	.DEF _TexteMenuTestTRobot=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_TableInfos:
	.DB  0x49,0x31,0x3E,0x20,0x3C,0x44,0x45,0x53
	.DB  0x49,0x47,0x4E,0x31,0x3E,0x20,0x20,0x20
	.DB  0x0,0x49,0x32,0x3E,0x20,0x56,0x65,0x72
	.DB  0x73,0x3D,0x32,0x2E,0x30,0x2E,0x30,0x62
	.DB  0x20,0x0,0x49,0x33,0x3E,0x20,0x30,0x33
	.DB  0x2F,0x30,0x35,0x2F,0x32,0x30,0x31,0x31
	.DB  0x20,0x20,0x0,0x49,0x34,0x3E,0x20,0x43
	.DB  0x6F,0x6E,0x6E,0x65,0x63,0x74,0x3D,0x41
	.DB  0x52,0x20,0x20,0x0,0x49,0x35,0x3E,0x20
	.DB  0x41,0x72,0x72,0x65,0x74,0x3D,0x20,0x4E
	.DB  0x4F,0x4E,0x20,0x20,0x0,0x49,0x36,0x3E
	.DB  0x20,0x46,0x53,0x31,0x31,0x3D,0x50,0x52
	.DB  0x4F,0x46,0x20,0x20,0x20,0x0,0x49,0x37
	.DB  0x3E,0x20,0x46,0x53,0x31,0x32,0x3D,0x50
	.DB  0x52,0x4F,0x46,0x20,0x20,0x20,0x0,0x49
	.DB  0x38,0x3E,0x20,0x46,0x53,0x31,0x33,0x3D
	.DB  0x50,0x52,0x4F,0x46,0x20,0x20,0x20,0x0
_Tab_Aff_Reg:
	.DB  0x43,0x65,0x6E,0x74,0x72,0x65,0x20,0x4D
	.DB  0x47,0x20,0x3D,0x0,0x43,0x65,0x6E,0x74
	.DB  0x72,0x65,0x20,0x4D,0x44,0x20,0x3D,0x0
	.DB  0x44,0x72,0x6F,0x69,0x74,0x65,0x20,0x4D
	.DB  0x47,0x20,0x3D,0x0,0x44,0x72,0x6F,0x69
	.DB  0x74,0x65,0x20,0x4D,0x44,0x20,0x3D,0x0
	.DB  0x44,0x72,0x6F,0x69,0x74,0x65,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x44,0x72,0x6F,0x69
	.DB  0x74,0x65,0x2B,0x20,0x4D,0x44,0x3D,0x0
	.DB  0x44,0x72,0x6F,0x69,0x74,0x32,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x44,0x72,0x6F,0x69
	.DB  0x74,0x32,0x2B,0x20,0x4D,0x44,0x3D,0x0
	.DB  0x44,0x72,0x6F,0x69,0x74,0x33,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x44,0x72,0x6F,0x69
	.DB  0x74,0x33,0x2B,0x20,0x4D,0x44,0x3D,0x0
	.DB  0x44,0x72,0x6F,0x69,0x74,0x34,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x44,0x72,0x6F,0x69
	.DB  0x74,0x34,0x2B,0x20,0x4D,0x44,0x3D,0x0
	.DB  0x47,0x61,0x75,0x63,0x68,0x65,0x20,0x4D
	.DB  0x47,0x20,0x3D,0x0,0x47,0x61,0x75,0x63
	.DB  0x68,0x65,0x20,0x4D,0x44,0x20,0x3D,0x0
	.DB  0x47,0x61,0x75,0x63,0x68,0x65,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x47,0x61,0x75,0x63
	.DB  0x68,0x65,0x2B,0x20,0x4D,0x44,0x3D,0x0
	.DB  0x47,0x61,0x75,0x63,0x68,0x32,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x47,0x61,0x75,0x63
	.DB  0x68,0x32,0x2B,0x20,0x4D,0x44,0x3D,0x0
	.DB  0x47,0x61,0x75,0x63,0x68,0x33,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x47,0x61,0x75,0x63
	.DB  0x68,0x33,0x2B,0x20,0x4D,0x44,0x3D,0x0
	.DB  0x47,0x61,0x75,0x63,0x68,0x34,0x2B,0x20
	.DB  0x4D,0x47,0x3D,0x0,0x47,0x61,0x75,0x63
	.DB  0x68,0x34,0x2B,0x20,0x4D,0x44,0x3D,0x0
_flecheHaut:
	.DB  0x4,0xE,0x15,0x4,0x4,0x4,0x4,0x0
_flecheBas:
	.DB  0x4,0x4,0x4,0x4,0x15,0xE,0x4,0x0
_Table_Calcul_OCR1x_PROF:
	.DB  0x0,0x0,0x5,0xD,0xA,0x19,0xF,0x26
	.DB  0x14,0x33,0x19,0x40,0x1E,0x4C,0x23,0x59
	.DB  0x28,0x66,0x2D,0x73,0x32,0x80,0x37,0x8C
	.DB  0x3C,0x99,0x41,0xA6,0x46,0xB3,0x4B,0xBF
	.DB  0x50,0xCD,0x55,0xDB,0x5A,0xE9,0x5F,0xE9
	.DB  0x64,0xFD
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  LOW(_0x0*2+85),HIGH(_0x0*2+85)
_0x4:
	.DB  LOW(_0x0*2+102),HIGH(_0x0*2+102)
_0x5:
	.DB  LOW(_0x0*2+119),HIGH(_0x0*2+119)
_0x6:
	.DB  LOW(_0x0*2+136),HIGH(_0x0*2+136)
_0x7:
	.DB  LOW(_0x0*2+153),HIGH(_0x0*2+153)
_0x8:
	.DB  LOW(_0x0*2+170),HIGH(_0x0*2+170)
_0x9:
	.DB  LOW(_0x0*2+187),HIGH(_0x0*2+187)
_0xA:
	.DB  LOW(_0x0*2+204),HIGH(_0x0*2+204)
_0xB:
	.DB  0x1
_0xC:
	.DB  0x0,0x0,0x0,0x0,0x4C,0x4C,0x0,0x0
	.DB  0x0,0x0,0x19,0x33,0x4C,0x66,0x7F,0x99
	.DB  0xB2,0xCC,0xE5,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x10,0x0,0x1,0x0,0x0,0x0,0x5
	.DB  0x5,0x0,0x0,0x1,0x1,0x1
_0x157:
	.DB  LOW(_0x0*2),HIGH(_0x0*2),LOW(_0x0*2+17),HIGH(_0x0*2+17),LOW(_0x0*2+34),HIGH(_0x0*2+34),LOW(_0x0*2+51),HIGH(_0x0*2+51)
	.DB  LOW(_0x0*2+68),HIGH(_0x0*2+68)
_0x0:
	.DB  0x20,0x20,0x20,0x20,0x56,0x5F,0x32,0x5F
	.DB  0x32,0x5F,0x30,0x62,0x20,0x20,0x20,0x20
	.DB  0x0,0x20,0x20,0x5B,0x31,0x31,0x2F,0x30
	.DB  0x35,0x2F,0x32,0x30,0x31,0x31,0x5D,0x20
	.DB  0x20,0x0,0x31,0x2E,0x52,0x65,0x67,0x6C
	.DB  0x20,0x63,0x6F,0x65,0x66,0x20,0x4D,0x6F
	.DB  0x74,0x20,0x0,0x32,0x2E,0x41,0x63,0x74
	.DB  0x69,0x76,0x2E,0x20,0x52,0x6F,0x62,0x6F
	.DB  0x74,0x20,0x20,0x0,0x33,0x2E,0x54,0x65
	.DB  0x73,0x74,0x20,0x64,0x75,0x20,0x52,0x6F
	.DB  0x62,0x6F,0x74,0x20,0x0,0x34,0x2E,0x49
	.DB  0x6E,0x66,0x6F,0x72,0x6D,0x61,0x74,0x69
	.DB  0x6F,0x6E,0x73,0x20,0x20,0x0,0x33,0x2E
	.DB  0x31,0x20,0x54,0x65,0x73,0x74,0x20,0x53
	.DB  0x65,0x72,0x76,0x6F,0x73,0x20,0x0,0x33
	.DB  0x2E,0x32,0x20,0x54,0x73,0x74,0x20,0x4D
	.DB  0x6F,0x74,0x65,0x75,0x72,0x73,0x20,0x0
	.DB  0x33,0x2E,0x33,0x20,0x54,0x73,0x74,0x20
	.DB  0x43,0x70,0x74,0x4C,0x69,0x67,0x6E,0x20
	.DB  0x0,0x33,0x2E,0x34,0x20,0x54,0x73,0x74
	.DB  0x20,0x43,0x70,0x74,0x43,0x69,0x62,0x6C
	.DB  0x20,0x0,0x33,0x2E,0x35,0x20,0x54,0x73
	.DB  0x74,0x20,0x54,0x78,0x20,0x49,0x42,0x4D
	.DB  0x20,0x20,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x5B,0x45,0x6E,0x74
	.DB  0x72,0x5D,0x20,0x0,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x5B,0x45,0x63,0x68
	.DB  0x61,0x70,0x5D,0x20,0x0,0x45,0x4E,0x54
	.DB  0x52,0x3E,0x4D,0x65,0x6D,0x6F,0x20,0x5B
	.DB  0x45,0x43,0x48,0x5D,0x0,0x43,0x64,0x65
	.DB  0x20,0x53,0x65,0x72,0x76,0x6F,0x5F,0x25
	.DB  0x2D,0x75,0x3D,0x20,0x25,0x2D,0x75,0x20
	.DB  0x20,0x20,0x0,0x5B,0x2B,0x5D,0x20,0x5B
	.DB  0x2D,0x5D,0x20,0x5B,0x45,0x63,0x68,0x70
	.DB  0x5D,0x20,0x20,0x0,0x52,0x61,0x70,0x2E
	.DB  0x20,0x63,0x79,0x63,0x6C,0x20,0x3D,0x20
	.DB  0x25,0x2D,0x75,0x25,0x25,0x0,0x5B,0x2B
	.DB  0x5D,0x20,0x5B,0x2D,0x5D,0x20,0x5B,0x45
	.DB  0x63,0x68,0x61,0x70,0x5D,0x20,0x0,0x50
	.DB  0x6F,0x73,0x20,0x3D,0x20,0x48,0x6F,0x72
	.DB  0x73,0x20,0x6C,0x69,0x67,0x6E,0x65,0x0
	.DB  0x50,0x6F,0x73,0x20,0x3D,0x20,0x47,0x61
	.DB  0x75,0x63,0x68,0x65,0x20,0x33,0x2B,0x20
	.DB  0x0,0x50,0x6F,0x73,0x20,0x3D,0x20,0x47
	.DB  0x61,0x75,0x63,0x68,0x65,0x20,0x32,0x2B
	.DB  0x20,0x0,0x50,0x6F,0x73,0x20,0x3D,0x20
	.DB  0x43,0x65,0x6E,0x74,0x72,0x65,0x5F,0x31
	.DB  0x20,0x20,0x0,0x50,0x6F,0x73,0x20,0x3D
	.DB  0x20,0x47,0x61,0x75,0x63,0x68,0x65,0x20
	.DB  0x2B,0x20,0x20,0x0,0x50,0x6F,0x73,0x20
	.DB  0x3D,0x20,0x43,0x65,0x6E,0x74,0x72,0x65
	.DB  0x5F,0x33,0x20,0x20,0x0,0x50,0x6F,0x73
	.DB  0x20,0x3D,0x20,0x47,0x61,0x75,0x63,0x68
	.DB  0x65,0x20,0x20,0x20,0x20,0x0,0x50,0x6F
	.DB  0x73,0x20,0x3D,0x20,0x44,0x72,0x6F,0x69
	.DB  0x74,0x65,0x20,0x33,0x2B,0x20,0x0,0x50
	.DB  0x6F,0x73,0x20,0x3D,0x20,0x44,0x72,0x6F
	.DB  0x69,0x74,0x65,0x20,0x32,0x2B,0x20,0x0
	.DB  0x50,0x6F,0x73,0x20,0x3D,0x20,0x44,0x72
	.DB  0x6F,0x69,0x74,0x65,0x20,0x2B,0x20,0x20
	.DB  0x0,0x50,0x6F,0x73,0x20,0x3D,0x20,0x44
	.DB  0x72,0x6F,0x69,0x74,0x65,0x20,0x20,0x20
	.DB  0x20,0x0,0x50,0x6F,0x73,0x20,0x3D,0x20
	.DB  0x43,0x65,0x6E,0x74,0x72,0x65,0x5F,0x35
	.DB  0x20,0x20,0x0,0x50,0x6F,0x73,0x20,0x3D
	.DB  0x20,0x3F,0x3F,0x3F,0x3F,0x3F,0x20,0x20
	.DB  0x20,0x20,0x20,0x0,0x5B,0x25,0x2D,0x69
	.DB  0x5D,0x20,0x20,0x20,0x20,0x20,0x5B,0x45
	.DB  0x43,0x48,0x41,0x50,0x5D,0x0,0x21,0x54
	.DB  0x65,0x73,0x74,0x20,0x64,0x65,0x73,0x61
	.DB  0x63,0x74,0x69,0x76,0x65,0x21,0x0,0x43
	.DB  0x6F,0x6D,0x70,0x69,0x6C,0x20,0x41,0x76
	.DB  0x65,0x63,0x5F,0x41,0x72,0x72,0x65,0x0
	.DB  0x43,0x6F,0x64,0x65,0x20,0x3D,0x20,0x30
	.DB  0x78,0x25,0x2D,0x78,0x25,0x2D,0x78,0x20
	.DB  0x5B,0x25,0x2D,0x63,0x5D,0x0,0x5B,0x2B
	.DB  0x2F,0x2D,0x5D,0x5B,0x53,0x45,0x54,0x5D
	.DB  0x5B,0x45,0x43,0x48,0x5D,0x20,0x0,0x44
	.DB  0x65,0x70,0x61,0x72,0x74,0x20,0x64,0x61
	.DB  0x6E,0x73,0x20,0x25,0x2D,0x75,0x73,0x0
	.DB  0x5B,0x45,0x63,0x68,0x5D,0x3E,0x44,0x65
	.DB  0x73,0x61,0x63,0x74,0x69,0x76,0x65,0x72
	.DB  0x0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x20A0003:
	.DB  0x1
_0x20C0003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  _TexteMenuInfos
	.DW  _0x3*2

	.DW  0x02
	.DW  _TexteMenuTestServos
	.DW  _0x4*2

	.DW  0x02
	.DW  _TexteMenuTestMoteurs
	.DW  _0x5*2

	.DW  0x02
	.DW  _TexteMenuTestCaptLigne
	.DW  _0x6*2

	.DW  0x02
	.DW  _TexteMenuTestCaptCible
	.DW  _0x7*2

	.DW  0x02
	.DW  _TexteMenuTestTransmIBM
	.DW  _0x8*2

	.DW  0x02
	.DW  _Ligne1ChoixEntr
	.DW  _0x9*2

	.DW  0x02
	.DW  _Ligne1ChoixEchap
	.DW  _0xA*2

	.DW  0x01
	.DW  _Menu_1
	.DW  _0xB*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x157*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

	.DW  0x01
	.DW  _Etat_BP_I2C_S1050000000
	.DW  _0x20A0003*2

	.DW  0x02
	.DW  __base_y_G106
	.DW  _0x20C0003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.8a Standard
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;--------------------------------------------------------
;Project : PPE robot suiveur de ligne
;Version : 2.2.0
;Date de cration   : 19/03/2008
;Dernire mise  jour :  03/05/2011
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin
;--------------------------------------------------------
;Comments:
;Les LED et le clavier sont commands par I2C soft.
;A l'arrt: Modification des paramtres PWM sur le robot,
;test des servos, test des moteurs, test du capteur ligne
;et test du capteur constitu de 5 cellules infrarouge,
;informations (Nom du robot, version, date de rvision
;etc.)
;En dplacement: Affichage de la position du robot par
;rapport  la ligne sur les cinq LED de droite.
;Affichage Erreur de mesure sur les trois LED de gauche
;Arrt devant la cible et tir (compilation conditionnelle)
;--------------------------------------------------------
;Chip type               : ATmega32
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;// ATTENTION : Fichier principal du projet (Ne pas modifier)
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
;
;//============================================================================================================
;// Bibliothques
;//------------------------------------------------------------------------------------------------------------
;// En tte des bibliothques CVAVR situes dans le rpertoire \CVAVR\INC, bibliothques dans \CVAVR\lib
;//------------------------------------------------------------------------------------------------------------
;#include <delay.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <string.h>
;#include <math.h>
;//------------------------------------------------------------------------------------------------------------
;// En tte des bibliothques dveloppes pour la carte SISI situes dans le rpertoire du projet
;//------------------------------------------------------------------------------------------------------------
;#include "PCF8574.h"        // Contient les fonctions: Ecrire_Port_I2C_Soft, Lire_Port_I2C_Soft
;
;#include "RB220.h"          // Paramtrage de la programmation
;
;#include "SISI2SVL.h"       // Contient les fonctions: Lire_BP_I2C_Soft, Affiche_LCD, Arret_Moteurs,
;                            // Active_Moteurs, Affiche_Fleche
;
;#include "RBELEVE.h"        // Contient la dclaration du sous-programme Mode_Run()
;//============================================================================================================
;// Dclarations
;//------------------------------------------------------------------------------------------------------------
;// Transfert IBM
;#define ClkIBM  PORTD.1
;#define DataIBM PORTD.0
;//------------------------------------------------------------------------------------------------------------
;// Tempo avant dpart
;#define Attente_Avant_Depart    5
;//============================================================================================================
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x18
   .equ __sda_bit=1
   .equ __scl_bit=0
; 0000 0050 #endasm
;#include <i2c.h>
;
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x15
; 0000 0056 #endasm
;#include <lcd.h>
;//============================================================================================================
;
;//============================================================================================================
;// 1) CONSTANTES
;//------------------------------------------------------------------------------------------------------------
;// 11)Constantes en flash
;//------------------------------------------------------------------------------------------------------------
;// Infos
;//------------------------------------------------------------------------------------------------------------
;flash struct Infos {
;          char PremiereLigne[17];
;        } TableInfos[] = { "I1> <DESIGN1>   ",
;                           "I2> Vers=2.0.0b ",
;                           "I3> 03/05/2011  ",
;                           #if POSITIONCONNECTEUR==CONNECTEURAV
;                           "I4> Connect=AV  ",
;                           #else
;                           "I4> Connect=AR  ",
;                           #endif
;                           #if PARCOURS_ROBOT==SANS_ARRET
;                           "I5> Arret= NON  ",
;                           #else
;                           "I5> Arret= OUI  ",
;                           #endif
;                           #if FS11==SOLUTIONELEVE
;                           "I6> FS11=ELEVE  ",
;                           #else
;                           "I6> FS11=PROF   ",
;                           #endif
;                           #if FS12==SOLUTIONELEVE
;                           "I7> FS12=ELEVE  ",
;                           #else
;                           "I7> FS12=PROF   ",
;                           #endif
;                           #if FS13==SOLUTIONELEVE
;                           "I8> FS13=ELEVE  ",
;                           #else
;                           "I8> FS13=PROF   ",
;                           #endif
;                         };
;//------------------------------------------------------------------------------------------------------------
;// Texte des sous-menus " Rglage des paramtres PWM "
;//------------------------------------------------------------------------------------------------------------
;flash struct Affichage_reglages {
;        char ligne0[12]; // 12 caractres + fin de ligne arrondi  l'entier pair suprieur
;        char ligne1[12]; // Ligne0 = 1er ligne de l'affichage
;        } Tab_Aff_Reg[11]= {{"Centre MG =","Centre MD ="},
;                    {"Droite MG =","Droite MD ="},
;                    {"Droite+ MG=","Droite+ MD="},
;                    {"Droit2+ MG=","Droit2+ MD="},
;                    {"Droit3+ MG=","Droit3+ MD="},
;                    {"Droit4+ MG=","Droit4+ MD="},
;                    {"Gauche MG =","Gauche MD ="},
;                    {"Gauche+ MG=","Gauche+ MD="},
;                    {"Gauch2+ MG=","Gauch2+ MD="},
;                    {"Gauch3+ MG=","Gauch3+ MD="},
;                    {"Gauch4+ MG=","Gauch4+ MD="}};
;
;//------------------------------------------------------------------------------------------------------------
;// Messages pour le LCD
;//------------------------------------------------------------------------------------------------------------
;flash char *Texte_Accueil_Ligne0 	= "    V_2_2_0b    ";
;flash char *Texte_Accueil_Ligne1 	= "  [11/05/2011]  ";
;flash char *TexteMenuCoefMot        = "1.Regl coef Mot ";
;flash char *TexteMenuActiveRobot    = "2.Activ. Robot  ";
;flash char *TexteMenuTestTRobot     = "3.Test du Robot ";
;flash char *TexteMenuInfos          = "4.Informations  ";

	.DSEG
;flash char *TexteMenuTestServos     = "3.1 Test Servos ";
;flash char *TexteMenuTestMoteurs    = "3.2 Tst Moteurs ";
;flash char *TexteMenuTestCaptLigne  = "3.3 Tst CptLign ";
;flash char *TexteMenuTestCaptCible  = "3.4 Tst CptCibl ";
;flash char *TexteMenuTestTransmIBM  = "3.5 Tst Tx IBM  ";
;flash char *Ligne1ChoixEntr	        = "         [Entr] ";
;flash char *Ligne1ChoixEchap	    = "        [Echap] ";
;//------------------------------------------------------------------------------------------------------------
;// Tables des caractres personnaliss:  placer dans la mmoire CGRAM du LCD
;//------------------------------------------------------------------------------------------------------------
;flash unsigned char flecheHaut[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM
;flash unsigned char flecheBas[] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM
;//------------------------------------------------------------------------------------------------------------
;// 12) Constantes en RAM
;//------------------------------------------------------------------------------------------------------------
;// Table de transcodage: Table_Calcul_OCR1x_PROF
;// Rle: Effectue le transcodage rapport cyclique alpha(%) -> valeur registre OCR1x
;//------------------------------------------------------------------------------------------------------------
;flash unsigned char Table_Calcul_OCR1x_PROF[21][2]={{0,0},{5,13},{10,25},{15,38},{20,51},{25,64},{30,76},
;{35,89},{40,102},{45,115},{50,128},{55,140},{60,153},{65,166},{70,179},{75,191},{80,205},{85,219},
;{90,233},{95,233},{100,253}};
;
;//------------------------------------------------------------------------------------------------------------
;//============================================================================================================
;
;//============================================================================================================
;// Variables globales
;//============================================================================================================
;// 1) Variables sauvegardes en eeprom
;//------------------------------------------------------------------------------------------------------------
;// Table des coefficients de rglage des signaux PWM (en %)  ( initialiser avec le fichier EEPROMROBOTBASE.eep
;// lors de la premire mise en oeuvre du robot (Voir prof)
;//------------------------------------------------------------------------------------------------------------
;eeprom unsigned char PWM_EEPROM[11][2];
;// Organisation de la table    PWM_EEPROM[11][2]
;//    Position     MG    MD
;//   n          [n,0] [n,1]
;// Centre       val00  val01
;// Droite
;// Droite+
;// Droite2+
;// Droite3+
;// HorsLigneD
;// Gauche
;// Gauche+
;// Gauche2+
;// Gauche3+
;// HorsLigneG
;//------------------------------------------------------------------------------------------------------------
;// 2) Variables en RAM
;//------------------------------------------------------------------------------------------------------------
;// Table des coefficients de rglage des signaux PWM (en %) utiliss pour la correction de trajectoire
;unsigned char PWM[11][2];		// Contient les coefficients destins au Timers(PWM) pour le rglage de la
;								// frquence de rotation des moteurs.
;//------------------------------------------------------------------------------------------------------------
;// Diffrents tats du graphe des transitions (menus)
;enum TMenu {Menu_Reglages, Menu_Run, Menu_Tests, Menu_Infos, Menu_Test_Servos, Menu_Test_Moteurs, Cde_Moteurs,
;       Reglage_PWM, Activation, Menu_Test_Capteurs_Ligne, Menu_Test_Capteurs_Cible, Menu_Test_Transm_IBM,
;       Transm_IBM, Menu_Affiche_Infos, Affiche_Reglages, Cde_Servo, Visu_Position,Visu_Cible}
;       Menu=Menu_Reglages, Menu_1=Menu_Run;
;//------------------------------------------------------------------------------------------------------------
;// Pour la dtection de la cible (utilis dans INT0, dans le menu VisuCible et par le SP Mode_RUN)
;//------------------------------------------------------------------------------------------------------------
;bit Cible = 0;                              // cible = 0 => pas de dtection, cible = 1 => dtection
;#if PARCOURS_ROBOT == AVEC_ARRET
;bit Cible_1 = 1;                            // Utiliser par le test du capteur ( l'arrt)
;#endif
;//============================================================================================================
;
;//============================================================================================================
;// Sous programme d'interruption dclench sur un front descendant de INT0
;// (Dtection de la cible par un contact reed ferm par la prsence d'un aimant)
;//------------------------------------------------------------------------------------------------------------
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 00E6 {

	.CSEG
_ext_int0_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00E7 // Dsactivation de l'INT0
; 0000 00E8 GICR=0x00; // Dsactivation INT0 (bit6 de GICR)
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 00E9 Arret_Moteurs();  // Arrt du robot
	CALL _Arret_Moteurs
; 0000 00EA Cible = 1;
	SET
	BLD  R2,0
; 0000 00EB }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;//============================================================================================================
;// Prototype des fonctions en cours de test
;void IBMTransfertChar(unsigned char Valeur);      // Transfert d'un octet dans une trame IBM PS2
;
;//============================================================================================================
;//============================================================================================================
;// Programme principal
;//============================================================================================================
;//============================================================================================================
;void main(void)
; 0000 00F6 { // Dbut du main
_main:
; 0000 00F7 //============================================================================================================
; 0000 00F8 // Variables locales  la fonction principale
; 0000 00F9 //------------------------------------------------------------------------------------------------------------
; 0000 00FA // type                   nom                                   Commentaires
; 0000 00FB //------------------------------------------------------------------------------------------------------------
; 0000 00FC unsigned char BP=0, Code_BP=0;                      // Etat des boutons-poussoirs de la carte SISI
; 0000 00FD unsigned char i=0, j=0, k=0;                        // Compteur d'usage gnral
; 0000 00FE unsigned char j_n=0, j_n_1=1;
; 0000 00FF unsigned char NumServo=1, NumServo_1=1;             // Saisie du numro du servo
; 0000 0100 unsigned char Aff_Cde_Servo=0, Aff_Cde_Servo_1=0;   // Valeur  envoyer au servo slectionn dans le menu Cde_Servo
; 0000 0101                                                     // Temporisation avant le passage en mode RUN
; 0000 0102 unsigned char decompte=Attente_Avant_Depart, decompte_1=Attente_Avant_Depart;
; 0000 0103 int i_n=0, i_n_1=1;                                 // Indices du tableau des structures d'affichage
; 0000 0104 unsigned char PositionRobotSVL = POS_HORS_LIGNE, PositionRobotSVL_1 = AR_GAUCHE_OU_AV_DROITE_3PLUS;
; 0000 0105 unsigned char VisuPositionSurLED;
; 0000 0106 char display_buffer_ligne0[17];                     // Tampon ligne 0 de l'afficheur LCD (16 caractres + /0)
; 0000 0107 char display_buffer_ligne1[17];                     // Tampon ligne 1 de l'afficheur LCD            "
; 0000 0108 char pourcentage0[3], pourcentage1[3];              // Affichage pourcentage PWM (0->95) (2 caractres + /0)
; 0000 0109 char *AffichePositionRobot;
; 0000 010A unsigned char rcycl=0, rcycl_1=0;                   // Saisie du rapport cyclique lors d'une modification manuelle
; 0000 010B //------------------------------------------------------------------------------------------------------------
; 0000 010C // Tableau des coefficients placs dans OCR1x pour le test "rglage du rapport cyclique du signal PWM"
; 0000 010D unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255};
; 0000 010E //------------------------------------------------------------------------------------------------------------
; 0000 010F // Gestion du protocole IBM
; 0000 0110 //------------------------------------------------------------------------------------------------------------
; 0000 0111 // Construction d'un octet avec le clavier
; 0000 0112 unsigned char MSByteIBM=0, LSByteIBM=0;
; 0000 0113 unsigned char QuartetIBM=0, AffQuartet_1 = 'L', AffQuartet = 'L';
; 0000 0114 // Transfert
; 0000 0115 unsigned int TrameIBM=0;
; 0000 0116 unsigned char CodeIBM_1=0, CodeIBM = 0;
; 0000 0117 //============================================================================================================
; 0000 0118 
; 0000 0119 //============================================================================================================
; 0000 011A // Initialisations
; 0000 011B //------------------------------------------------------------------------------------------------------------
; 0000 011C // Initialisation des priphriques
; 0000 011D //------------------------------------------------------------------------------------------------------------
; 0000 011E // Input/Output Ports initialization
; 0000 011F // Port A initialization
; 0000 0120 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out
; 0000 0121 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1
; 0000 0122                     // Gestion des Emetteurs_IR
; 0000 0123 PORTA=0xFF;         // Dsactivation des E_IR  la mise sous tension
	SBIW R28,63
	SBIW R28,15
	LDI  R24,78
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0xC*2)
	LDI  R31,HIGH(_0xC*2)
	CALL __INITLOCB
;	BP -> R17
;	Code_BP -> R16
;	i -> R19
;	j -> R18
;	k -> R21
;	j_n -> R20
;	j_n_1 -> Y+77
;	NumServo -> Y+76
;	NumServo_1 -> Y+75
;	Aff_Cde_Servo -> Y+74
;	Aff_Cde_Servo_1 -> Y+73
;	decompte -> Y+72
;	decompte_1 -> Y+71
;	i_n -> Y+69
;	i_n_1 -> Y+67
;	PositionRobotSVL -> Y+66
;	PositionRobotSVL_1 -> Y+65
;	VisuPositionSurLED -> Y+64
;	display_buffer_ligne0 -> Y+47
;	display_buffer_ligne1 -> Y+30
;	pourcentage0 -> Y+27
;	pourcentage1 -> Y+24
;	*AffichePositionRobot -> Y+22
;	rcycl -> Y+21
;	rcycl_1 -> Y+20
;	alpha -> Y+9
;	MSByteIBM -> Y+8
;	LSByteIBM -> Y+7
;	QuartetIBM -> Y+6
;	AffQuartet_1 -> Y+5
;	AffQuartet -> Y+4
;	TrameIBM -> Y+2
;	CodeIBM_1 -> Y+1
;	CodeIBM -> Y+0
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	LDI  R18,0
	LDI  R21,0
	LDI  R20,0
	LDI  R30,LOW(255)
	OUT  0x1B,R30
; 0000 0124 DDRA=0xFF;          // Port en sortie
	OUT  0x1A,R30
; 0000 0125 //------------------------------------------------------------------------------------------------------------
; 0000 0126 // Port B initialization
; 0000 0127 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=Out Func7=Out
; 0000 0128 // State0=T State1=T State2=T State3=T State4=T State5=T State6=0 State7=0
; 0000 0129 PORTB=0x00;        // SERVO1 sur PB6, SERVO2 sur PB7
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 012A DDRB=0xC0;
	LDI  R30,LOW(192)
	OUT  0x17,R30
; 0000 012B //------------------------------------------------------------------------------------------------------------
; 0000 012C // Port C initialization
; 0000 012D // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In
; 0000 012E // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T
; 0000 012F                     // Gestion de l'afficheur LCD
; 0000 0130 PORTC=0x00;         // Gre l'affichage, initialis par la fonction lcd_init(16);
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 0131 DDRC=0x00;
	OUT  0x14,R30
; 0000 0132 //------------------------------------------------------------------------------------------------------------
; 0000 0133 // Port D initialization
; 0000 0134 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=Out
; 0000 0135 // State7=0 State6=0 State5=1 State4=1 State3=T State2=T State1=1 State0=1
; 0000 0136 
; 0000 0137                     // Capteur magntique, moteurs, S4 et liaison srie
; 0000 0138 PORTD=0x33;         // Capteur magntique reli au 0V sur PD2
	LDI  R30,LOW(51)
	OUT  0x12,R30
; 0000 0139 DDRD=0xF3;          // Broches PWM moteurs droit et gauche en sortie, initialise  1
	LDI  R30,LOW(243)
	OUT  0x11,R30
; 0000 013A                     // Cde Servo 1 et 2 en sortie, Initialises  0
; 0000 013B                     // ClkIBM et DataIBM en sortie, Initialiss  1
; 0000 013C //------------------------------------------------------------------------------------------------------------
; 0000 013D // Timer/Counter 1 initialization
; 0000 013E // Clock source: System Clock
; 0000 013F // Clock value: 8000,000 kHz
; 0000 0140 // Mode: Ph. correct PWM top=00FFh
; 0000 0141 // OC1A output: Inverted
; 0000 0142 // OC1B output: Inverted
; 0000 0143 // Noise Canceler: Off
; 0000 0144 // Input Capture on Falling Edge
; 0000 0145 TCCR1A=0xF1; // 0xA1 pour robot 2008, 0xF1 pour robot 2009
	LDI  R30,LOW(241)
	OUT  0x2F,R30
; 0000 0146 TCCR1B=0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
; 0000 0147 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 0148 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0149 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 014A OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 014B OCR1BH=0x00;
	OUT  0x29,R30
; 0000 014C OCR1BL=0x00;
	OUT  0x28,R30
; 0000 014D //------------------------------------------------------------------------------------------------------------
; 0000 014E // External Interrupt(s) initialization
; 0000 014F // INT0: On
; 0000 0150 // INT0 Mode: Falling Edge
; 0000 0151 // INT1: Off
; 0000 0152 // INT2: Off
; 0000 0153 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
; 0000 0154 MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
; 0000 0155 MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 0156 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 0157 //------------------------------------------------------------------------------------------------------------
; 0000 0158 // Analog Comparator initialization
; 0000 0159 // Analog Comparator: On
; 0000 015A // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 015B // Analog Comparator Output: Off
; 0000 015C ACSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 015D SFIOR=0x00;
	OUT  0x30,R30
; 0000 015E //------------------------------------------------------------------------------------------------------------
; 0000 015F // LCD module initialization
; 0000 0160 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
; 0000 0161 //------------------------------------------------------------------------------------------------------------
; 0000 0162 // Chargement initial de la mmoire CGRAM de l'afficheur avec deux caractres personaliss
; 0000 0163 //------------------------------------------------------------------------------------------------------------
; 0000 0164 for (i=0;i<8;i++)
	LDI  R19,LOW(0)
_0xE:
	CPI  R19,8
	BRSH _0xF
; 0000 0165 {
; 0000 0166  lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]);      // @1 Caractre flche haut
	MOV  R30,R19
	SUBI R30,-LOW(64)
	ST   -Y,R30
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_flecheHaut*2)
	SBCI R31,HIGH(-_flecheHaut*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
; 0000 0167  lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]);       // @2 Caractre flche bas
	MOV  R30,R19
	SUBI R30,-LOW(72)
	ST   -Y,R30
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_flecheBas*2)
	SBCI R31,HIGH(-_flecheBas*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
; 0000 0168 }
	SUBI R19,-1
	RJMP _0xE
_0xF:
; 0000 0169 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 016A // Initialisation de la position des Servos
; 0000 016B CDE_SERVO1 = 0;
	CBI  0x12,6
; 0000 016C CDE_SERVO2 = 0;
	CBI  0x12,7
; 0000 016D //----------------------------------------------------------------------------------------------------------------------------------
; 0000 016E //----------------------------------------------------------------------------------------------------------------------------------
; 0000 016F // Message d'accueil
; 0000 0170 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 0171 lcd_clear();
	CALL _lcd_clear
; 0000 0172 sprintf(display_buffer_ligne0,Texte_Accueil_Ligne0); // Version du logiciel  remplacer par le nom du robot
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R5
	ST   -Y,R4
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0173 sprintf(display_buffer_ligne1,Texte_Accueil_Ligne1);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R7
	ST   -Y,R6
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0174 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0175 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0176 //==================================================================================================================================
; 0000 0177 
; 0000 0178 //==================================================================================================================================
; 0000 0179 // Boucle principale
; 0000 017A //----------------------------------------------------------------------------------------------------------------------------------
; 0000 017B while (1)
_0x14:
; 0000 017C {
; 0000 017D   BP = Lire_BP_I2C_Soft();                          // Lecture BP pour volution du graphe des menus
	CALL _Lire_BP_I2C_Soft
	MOV  R17,R30
; 0000 017E                                                     // Gestion anti-rebonds
; 0000 017F   Code_BP =  Lire_Port_I2C_Soft(Add_BP_I2C);        // Lecture BP pour affichage sur les LED
	LDI  R30,LOW(66)
	ST   -Y,R30
	CALL _Lire_Port_I2C_Soft
	MOV  R16,R30
; 0000 0180                                                     // Code BP = Code LED
; 0000 0181 
; 0000 0182   switch (Menu)
	LDS  R30,_Menu
	LDI  R31,0
; 0000 0183    { // Dbut du switch principal
; 0000 0184 //==================================================================================================================================
; 0000 0185 // Dbut Menus
; 0000 0186 ///=================================================================================================================================
; 0000 0187 // Dbut de menus de NIVEAU 1
; 0000 0188 // Menu 1 : Rglage des coefficients moteur
; 0000 0189 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 018A       case Menu_Reglages :  if (Menu_1 != Menu)
	SBIW R30,0
	BREQ PC+3
	JMP _0x1A
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x1B
; 0000 018B                              {
; 0000 018C                                 sprintf(display_buffer_ligne0,TexteMenuCoefMot);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R9
	ST   -Y,R8
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 018D                                 sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 018E                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 018F                                 Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 0190                              }
; 0000 0191 
; 0000 0192                             switch(BP)
_0x1B:
	MOV  R30,R17
	LDI  R31,0
; 0000 0193                              {
; 0000 0194                                 case FlecheH_I2C: Menu = Menu_Infos;  break; // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x1F
	LDI  R30,LOW(3)
	RJMP _0x136
; 0000 0195                                 case FlecheB_I2C: Menu = Menu_Run;  break; // touche [flche haut]
_0x1F:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x20
	LDI  R30,LOW(1)
	RJMP _0x136
; 0000 0196                                 case ENTR_I2C: Menu = Affiche_Reglages;  break; // touche [Enter]
_0x20:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x22
	LDI  R30,LOW(14)
	RJMP _0x136
; 0000 0197                                 default: Menu = Menu_Reglages;
_0x22:
	LDI  R30,LOW(0)
_0x136:
	STS  _Menu,R30
; 0000 0198                                 }
; 0000 0199 
; 0000 019A                             Menu_1 = Menu_Reglages;
	LDI  R30,LOW(0)
	JMP  _0x137
; 0000 019B        break;
; 0000 019C //----------------------------------------------------------------------------------------------------------------------------------
; 0000 019D // Menu 2 : Activation Robot
; 0000 019E //----------------------------------------------------------------------------------------------------------------------------------
; 0000 019F        case Menu_Run :      if (Menu_1 != Menu)
_0x1A:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x23
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x24
; 0000 01A0                              {
; 0000 01A1                                 sprintf(display_buffer_ligne0,TexteMenuActiveRobot);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R11
	ST   -Y,R10
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01A2                                 sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01A3                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 01A4                                 Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 01A5                              }
; 0000 01A6 
; 0000 01A7                             switch(BP)
_0x24:
	MOV  R30,R17
	LDI  R31,0
; 0000 01A8                              {
; 0000 01A9                                 case FlecheH_I2C: Menu = Menu_Reglages; break; // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x28
	LDI  R30,LOW(0)
	RJMP _0x138
; 0000 01AA                                 case FlecheB_I2C: Menu = Menu_Tests; break; // touche [flche haut]
_0x28:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x29
	LDI  R30,LOW(2)
	RJMP _0x138
; 0000 01AB                                 case ENTR_I2C:                              // touche [Enter]
_0x29:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x2B
; 0000 01AC                                                 IBMTransfertChar(0x71);
	LDI  R30,LOW(113)
	ST   -Y,R30
	CALL _IBMTransfertChar
; 0000 01AD                                                 delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01AE                                                 IBMTransfertChar(0xaF);
	LDI  R30,LOW(175)
	ST   -Y,R30
	CALL _IBMTransfertChar
; 0000 01AF                                                 delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01B0                                                 IBMTransfertChar(0xCF);
	LDI  R30,LOW(207)
	ST   -Y,R30
	CALL _IBMTransfertChar
; 0000 01B1                                                 delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01B2                                                 Menu = Activation;
	LDI  R30,LOW(8)
	RJMP _0x138
; 0000 01B3                                 break;
; 0000 01B4                                 default: Menu = Menu_Run;
_0x2B:
	LDI  R30,LOW(1)
_0x138:
	STS  _Menu,R30
; 0000 01B5                              }
; 0000 01B6 
; 0000 01B7                             Menu_1 = Menu_Run;
	LDI  R30,LOW(1)
	JMP  _0x137
; 0000 01B8        break;
; 0000 01B9 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 01BA // Menu 3 : Test du robot
; 0000 01BB //----------------------------------------------------------------------------------------------------------------------------------
; 0000 01BC        case Menu_Tests :    if (Menu_1 != Menu)
_0x23:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2C
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x2D
; 0000 01BD                              {
; 0000 01BE                                 sprintf(display_buffer_ligne0,TexteMenuTestTRobot);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R13
	ST   -Y,R12
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01BF                                 sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01C0                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 01C1                                 Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 01C2                              }
; 0000 01C3 
; 0000 01C4                             switch(BP)
_0x2D:
	MOV  R30,R17
	LDI  R31,0
; 0000 01C5                              {
; 0000 01C6                                 case FlecheH_I2C: Menu = Menu_Run;  break; // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x31
	LDI  R30,LOW(1)
	RJMP _0x139
; 0000 01C7                                 case FlecheB_I2C: Menu = Menu_Infos;  break; // touche [flche haut]
_0x31:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x32
	LDI  R30,LOW(3)
	RJMP _0x139
; 0000 01C8                                 case ENTR_I2C: Menu = Menu_Test_Servos;  break; // touche [Enter]
_0x32:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x34
	LDI  R30,LOW(4)
	RJMP _0x139
; 0000 01C9                                 default: Menu = Menu_Tests ;
_0x34:
	LDI  R30,LOW(2)
_0x139:
	STS  _Menu,R30
; 0000 01CA                              }
; 0000 01CB 
; 0000 01CC                             Menu_1 = Menu_Tests;
	LDI  R30,LOW(2)
	JMP  _0x137
; 0000 01CD 
; 0000 01CE        break;
; 0000 01CF //----------------------------------------------------------------------------------------------------------------------------------
; 0000 01D0 // Menu 4 : Informations
; 0000 01D1 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 01D2        case Menu_Infos :  if (Menu_1 != Menu)
_0x2C:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x35
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x36
; 0000 01D3                              {
; 0000 01D4                                 sprintf(display_buffer_ligne0,TexteMenuInfos);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteMenuInfos
	LDS  R31,_TexteMenuInfos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01D5                                 sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01D6                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 01D7                                 Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 01D8                              }
; 0000 01D9 
; 0000 01DA                             switch(BP)
_0x36:
	MOV  R30,R17
	LDI  R31,0
; 0000 01DB                              {
; 0000 01DC                                 case FlecheH_I2C: Menu = Menu_Tests;  break; // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x3A
	LDI  R30,LOW(2)
	RJMP _0x13A
; 0000 01DD                                 case FlecheB_I2C: Menu = Menu_Reglages;  break; // touche [flche haut]
_0x3A:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x3B
	LDI  R30,LOW(0)
	RJMP _0x13A
; 0000 01DE                                 case ENTR_I2C: j_n = 0; Menu = Menu_Affiche_Infos;  break; // touche [Enter]
_0x3B:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x3D
	LDI  R20,LOW(0)
	LDI  R30,LOW(13)
	RJMP _0x13A
; 0000 01DF                                 default: Menu = Menu_Infos;
_0x3D:
	LDI  R30,LOW(3)
_0x13A:
	STS  _Menu,R30
; 0000 01E0                                 }
; 0000 01E1 
; 0000 01E2                             Menu_1 = Menu_Infos;
	LDI  R30,LOW(3)
	JMP  _0x137
; 0000 01E3        break;
; 0000 01E4 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 01E5 // Fin Menus de NIVEAU 1
; 0000 01E6 //==================================================================================================================================
; 0000 01E7 //==================================================================================================================================
; 0000 01E8 // Dbut des sous-menus (NIVEAU 2)
; 0000 01E9 //==================================================================================================================================
; 0000 01EA // Sous-menu 3.1 : Test des servos
; 0000 01EB //----------------------------------------------------------------------------------------------------------------------------------
; 0000 01EC        case Menu_Test_Servos : if (Menu_1 != Menu)
_0x35:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x3E
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x3F
; 0000 01ED                                 {
; 0000 01EE                                     sprintf(display_buffer_ligne0,TexteMenuTestServos);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteMenuTestServos
	LDS  R31,_TexteMenuTestServos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01EF                                     sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01F0                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 01F1                                     Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 01F2                                 }
; 0000 01F3 
; 0000 01F4                               switch(BP)
_0x3F:
	MOV  R30,R17
	LDI  R31,0
; 0000 01F5                                 {
; 0000 01F6                                      case FlecheH_I2C: Menu = Menu_Test_Transm_IBM;  break;     // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x43
	LDI  R30,LOW(11)
	RJMP _0x13B
; 0000 01F7                                      case FlecheB_I2C: Menu = Menu_Test_Moteurs;  break;            // touche [flche haut]
_0x43:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x44
	LDI  R30,LOW(5)
	RJMP _0x13B
; 0000 01F8                                      case ECHAP_I2C: Menu = Menu_Tests; break;                      // touche [Echap]
_0x44:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x45
	LDI  R30,LOW(2)
	RJMP _0x13B
; 0000 01F9                                      case ENTR_I2C: Menu = Cde_Servo;                               // touche [Enter]
_0x45:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x47
	LDI  R30,LOW(15)
	STS  _Menu,R30
; 0000 01FA                                                      Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;
	LDI  R30,0
	SBIC 0x10,6
	LDI  R30,1
	__PUTB1SX 74
; 0000 01FB                                      break;
	RJMP _0x42
; 0000 01FC                                      default: Menu = Menu_Test_Servos;
_0x47:
	LDI  R30,LOW(4)
_0x13B:
	STS  _Menu,R30
; 0000 01FD                                 }
_0x42:
; 0000 01FE 
; 0000 01FF                               Menu_1 = Menu_Test_Servos;
	LDI  R30,LOW(4)
	JMP  _0x137
; 0000 0200        break;
; 0000 0201 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 0202 // Sous-menu 3.2 :  Test des moteurs
; 0000 0203 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 0204        case Menu_Test_Moteurs : if (Menu_1 != Menu)
_0x3E:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x48
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x49
; 0000 0205                                  {
; 0000 0206                                     sprintf(display_buffer_ligne0,TexteMenuTestMoteurs);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteMenuTestMoteurs
	LDS  R31,_TexteMenuTestMoteurs+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0207                                     sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0208                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0209                                     Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 020A                                  }
; 0000 020B 
; 0000 020C                                 switch(BP)
_0x49:
	MOV  R30,R17
	LDI  R31,0
; 0000 020D                                  {
; 0000 020E                                     case FlecheH_I2C: Menu = Menu_Test_Servos;  break; // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x4D
	LDI  R30,LOW(4)
	RJMP _0x13C
; 0000 020F                                     case FlecheB_I2C: Menu = Menu_Test_Capteurs_Ligne;  break; // touche [flche haut]
_0x4D:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x4E
	LDI  R30,LOW(9)
	RJMP _0x13C
; 0000 0210                                     case ECHAP_I2C: Menu = Menu_Tests; break; // touche [Echap]
_0x4E:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x4F
	LDI  R30,LOW(2)
	RJMP _0x13C
; 0000 0211                                     case ENTR_I2C: rcycl = 0; rcycl_1 = 0; Menu = Cde_Moteurs;  break; // touche [Enter]
_0x4F:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x51
	LDI  R30,LOW(0)
	STD  Y+21,R30
	STD  Y+20,R30
	LDI  R30,LOW(6)
	RJMP _0x13C
; 0000 0212                                     default: Menu = Menu_Test_Moteurs;
_0x51:
	LDI  R30,LOW(5)
_0x13C:
	STS  _Menu,R30
; 0000 0213                                  }
; 0000 0214 
; 0000 0215                                 Menu_1 = Menu_Test_Moteurs;
	LDI  R30,LOW(5)
	JMP  _0x137
; 0000 0216        break;
; 0000 0217 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 0218 // Sous-menu 3.3 :  Test du capteur ligne
; 0000 0219 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 021A        case Menu_Test_Capteurs_Ligne :  if (Menu_1 != Menu)
_0x48:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x52
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x53
; 0000 021B                                             {
; 0000 021C                                                 sprintf(display_buffer_ligne0,TexteMenuTestCaptLigne);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteMenuTestCaptLigne
	LDS  R31,_TexteMenuTestCaptLigne+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 021D                                                 sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 021E                                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 021F                                                 Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 0220                                             }
; 0000 0221 
; 0000 0222                                         switch(BP)
_0x53:
	MOV  R30,R17
	LDI  R31,0
; 0000 0223                                             {
; 0000 0224                                                 case FlecheH_I2C: Menu = Menu_Test_Moteurs;  break;     // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x57
	LDI  R30,LOW(5)
	RJMP _0x13D
; 0000 0225                                                 case FlecheB_I2C: Menu = Menu_Test_Capteurs_Cible;  break;     // touche [flche haut]
_0x57:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x58
	LDI  R30,LOW(10)
	RJMP _0x13D
; 0000 0226                                                 case ECHAP_I2C: Menu = Menu_Tests; break;             // touche [Echap]
_0x58:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x59
	LDI  R30,LOW(2)
	RJMP _0x13D
; 0000 0227                                                 case ENTR_I2C: Menu = Visu_Position;  break;         // touche [Enter]
_0x59:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x5B
	LDI  R30,LOW(16)
	RJMP _0x13D
; 0000 0228                                                 default: Menu = Menu_Test_Capteurs_Ligne;
_0x5B:
	LDI  R30,LOW(9)
_0x13D:
	STS  _Menu,R30
; 0000 0229                                             }
; 0000 022A 
; 0000 022B                                         Menu_1 = Menu_Test_Capteurs_Ligne;
	LDI  R30,LOW(9)
	JMP  _0x137
; 0000 022C         break;
; 0000 022D //----------------------------------------------------------------------------------------------------------------------------------
; 0000 022E // Sous-menu 3.4 : Test du capteur cible
; 0000 022F //----------------------------------------------------------------------------------------------------------------------------------
; 0000 0230         case Menu_Test_Capteurs_Cible : if (Menu_1 != Menu)
_0x52:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x5C
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x5D
; 0000 0231                                          {
; 0000 0232                                             sprintf(display_buffer_ligne0,TexteMenuTestCaptCible);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteMenuTestCaptCible
	LDS  R31,_TexteMenuTestCaptCible+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0233                                             sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0234                                             Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0235                                             Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 0236                                          }
; 0000 0237 
; 0000 0238                                         switch(BP)
_0x5D:
	MOV  R30,R17
	LDI  R31,0
; 0000 0239                                          {
; 0000 023A                                             case FlecheH_I2C: Menu = Menu_Test_Capteurs_Ligne;  break;     // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x61
	LDI  R30,LOW(9)
	RJMP _0x13E
; 0000 023B                                             case FlecheB_I2C: Menu = Menu_Test_Transm_IBM;  break;     // touche [flche haut]
_0x61:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x62
	LDI  R30,LOW(11)
	RJMP _0x13E
; 0000 023C                                             case ECHAP_I2C: Menu = Menu_Tests; break;             // touche [Echap]
_0x62:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x63
	LDI  R30,LOW(2)
	RJMP _0x13E
; 0000 023D                                             case ENTR_I2C: Menu = Visu_Cible;                     // touche [Enter]
_0x63:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x65
	LDI  R30,LOW(17)
	RJMP _0x13E
; 0000 023E                                                      #if PARCOURS_ROBOT == AVEC_ARRET
; 0000 023F                                                      #asm("sei");
; 0000 0240                                                      #endif
; 0000 0241                                             break;
; 0000 0242                                             default: Menu = Menu_Test_Capteurs_Cible;
_0x65:
	LDI  R30,LOW(10)
_0x13E:
	STS  _Menu,R30
; 0000 0243                                          }
; 0000 0244 
; 0000 0245                                         Menu_1 = Menu_Test_Capteurs_Cible;
	LDI  R30,LOW(10)
	RJMP _0x137
; 0000 0246         break;
; 0000 0247 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 0248 // Sous-menu 3.5 : Test transmission protocole IBM (vers carte MicroDesign)
; 0000 0249 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 024A  case Menu_Test_Transm_IBM : if (Menu_1 != Menu)
_0x5C:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x66
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x67
; 0000 024B                                          {
; 0000 024C                                             sprintf(display_buffer_ligne0,TexteMenuTestTransmIBM);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteMenuTestTransmIBM
	LDS  R31,_TexteMenuTestTransmIBM+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 024D                                             sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 024E                                             Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 024F                                             Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 0250                                          }
; 0000 0251 
; 0000 0252                                         switch(BP)
_0x67:
	MOV  R30,R17
	LDI  R31,0
; 0000 0253                                          {
; 0000 0254                                             case FlecheH_I2C: Menu =  Menu_Test_Capteurs_Cible ;  break;     // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x6B
	LDI  R30,LOW(10)
	RJMP _0x13F
; 0000 0255                                             case FlecheB_I2C: Menu = Menu_Test_Servos;  break;     // touche [flche haut]
_0x6B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x6C
	LDI  R30,LOW(4)
	RJMP _0x13F
; 0000 0256                                             case ECHAP_I2C: Menu = Menu_Tests; break;             // touche [Echap]
_0x6C:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x6D
	LDI  R30,LOW(2)
	RJMP _0x13F
; 0000 0257                                             case ENTR_I2C: Menu = Transm_IBM;                     // touche [Enter]
_0x6D:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x6F
	LDI  R30,LOW(12)
	RJMP _0x13F
; 0000 0258                                             break;
; 0000 0259                                             default: Menu = Menu_Test_Transm_IBM;
_0x6F:
	LDI  R30,LOW(11)
_0x13F:
	STS  _Menu,R30
; 0000 025A                                          }
; 0000 025B 
; 0000 025C                                         Menu_1 = Menu_Test_Transm_IBM;
	LDI  R30,LOW(11)
	RJMP _0x137
; 0000 025D         break;
; 0000 025E //----------------------------------------------------------------------------------------------------------------------------------
; 0000 025F // Fin des sous-menus (NIVEAU 2)
; 0000 0260 //==================================================================================================================================
; 0000 0261 // Fin Menus
; 0000 0262 //==================================================================================================================================
; 0000 0263 // Dbut des affichages
; 0000 0264 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 0265 // Affichage des rglages PWM sous la forme d'un menu droulant
; 0000 0266        case Affiche_Reglages :  if ((Menu_1 != Menu) || (i_n_1 != i_n))
_0x66:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x70
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x72
	__GETW1SX 69
	__GETW2SX 67
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x72
	RJMP _0x71
_0x72:
; 0000 0267                                 {
; 0000 0268                                     if (fmod(i_n,2)==0) // Cas1: si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est pair
	__GETW1SX 69
	CALL __CWD1
	CALL __CDF1
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	CALL _fmod
	CALL __CPD10
	BREQ PC+3
	JMP _0x74
; 0000 0269                                     {   // Cas1: Affichage ligne (i_n/2) colonne 0 sur ligne 0 afficheur
; 0000 026A                                         sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__GETW2SX 71
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	CALL __MULW12U
	SUBI R30,LOW(-_Tab_Aff_Reg*2)
	SBCI R31,HIGH(-_Tab_Aff_Reg*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 026B                                         itoa(PWM_EEPROM[i_n/2][0],pourcentage0);
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 026C                                         strcat(display_buffer_ligne0,pourcentage0);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 026D                                         // Cas1: Affichage ligne (i_n/2) colonne 1 sur ligne 1 afficheur
; 0000 026E                                         sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2].ligne1);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__GETW2SX 71
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	CALL __MULW12U
	SUBI R30,LOW(-_Tab_Aff_Reg*2)
	SBCI R31,HIGH(-_Tab_Aff_Reg*2)
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 026F                                         itoa(PWM_EEPROM[i_n/2][1],pourcentage1);
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	RJMP _0x140
; 0000 0270                                         strcat(display_buffer_ligne1,pourcentage1);
; 0000 0271                                     }
; 0000 0272 
; 0000 0273                                     else  // si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est impair
_0x74:
; 0000 0274                                     {   // Cas2et3: Affichage ligne (i_n/2) colonne 1 sur ligne 0 afficheur
; 0000 0275                                         sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__GETW2SX 71
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	CALL __MULW12U
	SUBI R30,LOW(-_Tab_Aff_Reg*2)
	SBCI R31,HIGH(-_Tab_Aff_Reg*2)
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0276                                         itoa(PWM_EEPROM[i_n/2][1],pourcentage0);
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	CALL __EEPROMRDB
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 0277                                         strcat(display_buffer_ligne0,pourcentage0);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 0278 
; 0000 0279                                         if (i_n < 21) // et si la fin de la table AFFICHE_REGLAGE n'est pas atteinte
	__GETW2SX 69
	SBIW R26,21
	BRGE _0x76
; 0000 027A                                             {   // cas2: Affichage ligne ((i_n/2)+1) colonne 0 sur ligne 1 afficheur
; 0000 027B                                                 sprintf(display_buffer_ligne1,Tab_Aff_Reg[(i_n/2)+1].ligne0);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__GETW2SX 71
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	ADIW R30,1
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	CALL __MULW12U
	SUBI R30,LOW(-_Tab_Aff_Reg*2)
	SBCI R31,HIGH(-_Tab_Aff_Reg*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 027C                                                 itoa(PWM_EEPROM[(i_n/2)+1][0],pourcentage1);
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	MOVW R26,R30
	LSL  R26
	ROL  R27
	__ADDW2MN _PWM_EEPROM,2
	RJMP _0x140
; 0000 027D                                                 strcat(display_buffer_ligne1,pourcentage1);
; 0000 027E                                             }
; 0000 027F                                         else // et si la fin de la table AFFICHE_REGLAGE est atteinte
_0x76:
; 0000 0280                                             {   // cas3: Affichage ligne 0 colonne 0 sur ligne 1 afficheur
; 0000 0281                                                 sprintf(display_buffer_ligne1,Tab_Aff_Reg[0].ligne0);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Tab_Aff_Reg*2)
	LDI  R31,HIGH(_Tab_Aff_Reg*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0282                                                 itoa(PWM_EEPROM[0][0],pourcentage1);
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
_0x140:
	CALL __EEPROMRDB
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 0283                                                 strcat(display_buffer_ligne1,pourcentage1);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 0284                                             }
; 0000 0285                                     }
; 0000 0286                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0287                                     lcd_gotoxy(14,0); lcd_putchar('%');
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(37)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 0288                                     lcd_gotoxy(15,0);    // Affichage flecheHaut
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 0289                                     lcd_putchar(Caractere_FlecheH);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 028A                                     lcd_gotoxy(14,1); lcd_putchar('%');
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(37)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 028B                                     lcd_gotoxy(15,1);    // Affichage flecheBas
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 028C                                     lcd_putchar(Caractere_FlecheB);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 028D                                     i_n_1 = i_n; // Notifie que l'affichage a chang
	__GETW1SX 69
	__PUTW1SX 67
; 0000 028E                                  }
; 0000 028F 
; 0000 0290                                 switch(BP)
_0x71:
	MOV  R30,R17
	LDI  R31,0
; 0000 0291                                 {
; 0000 0292                                     // Gestion de l'indice i_n du tableau AFFICHE_REGLAGE dans l'intervalle [0,21]
; 0000 0293                                     case FlecheH_I2C: if (i_n < 21) i_n++; else i_n=0; break;   // touche [flche haut]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x7B
	__GETW2SX 69
	SBIW R26,21
	BRGE _0x7C
	MOVW R26,R28
	SUBI R26,LOW(-(69))
	SBCI R27,HIGH(-(69))
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x7D
_0x7C:
	LDI  R30,LOW(0)
	__CLRW1SX 69
_0x7D:
	RJMP _0x7A
; 0000 0294                                     case FlecheB_I2C: if (i_n > 0) i_n--; else i_n=21; break;   // touche [flche bas]
_0x7B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x7E
	__GETW2SX 69
	CALL __CPW02
	BRGE _0x7F
	MOVW R26,R28
	SUBI R26,LOW(-(69))
	SBCI R27,HIGH(-(69))
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x80
_0x7F:
	LDI  R30,LOW(21)
	LDI  R31,HIGH(21)
	__PUTW1SX 69
_0x80:
	RJMP _0x7A
; 0000 0295                                     case ECHAP_I2C: Menu = Menu_Reglages; break;                // touche [Echap]
_0x7E:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x81
	LDI  R30,LOW(0)
	RJMP _0x141
; 0000 0296                                             // La touche [Enter] fait passer la donne prsente sur la premire
; 0000 0297                                             // ligne de l'afficheur en mode modification
; 0000 0298                                     case ENTR_I2C:  if (fmod(i_n,2)==0) // si i_n pair
_0x81:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x85
	__GETW1SX 69
	CALL __CWD1
	CALL __CDF1
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	CALL _fmod
	CALL __CPD10
	BRNE _0x83
; 0000 0299                                                         rcycl = PWM_EEPROM[i_n/2][0];
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RJMP _0x142
; 0000 029A                                                     else  // si i_n impair
_0x83:
; 0000 029B                                                         rcycl = PWM_EEPROM[i_n/2][1];
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
_0x142:
	CALL __EEPROMRDB
	STD  Y+21,R30
; 0000 029C                                                     Menu = Reglage_PWM;
	LDI  R30,LOW(7)
	RJMP _0x141
; 0000 029D                                     break;
; 0000 029E                                     default: Menu = Affiche_Reglages;
_0x85:
	LDI  R30,LOW(14)
_0x141:
	STS  _Menu,R30
; 0000 029F                                 }
_0x7A:
; 0000 02A0 
; 0000 02A1                               Menu_1 = Affiche_Reglages;
	LDI  R30,LOW(14)
	RJMP _0x137
; 0000 02A2        break;
; 0000 02A3 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 02A4 //----------------------------------------------------------------------------------------------------------------------------------
; 0000 02A5        case Menu_Affiche_Infos : if ((Menu_1 != Menu) || (j_n != j_n_1))
_0x70:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x86
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x88
	__GETB1SX 77
	CP   R30,R20
	BREQ _0x87
_0x88:
; 0000 02A6                                 {
; 0000 02A7                                     sprintf(display_buffer_ligne0,TableInfos[j_n].PremiereLigne);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(17)
	MUL  R20,R26
	MOVW R30,R0
	SUBI R30,LOW(-_TableInfos*2)
	SBCI R31,HIGH(-_TableInfos*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02A8                                     sprintf(display_buffer_ligne1,Ligne1ChoixEchap);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02A9                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 02AA                                     Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 02AB                                     j_n_1 = j_n;
	__PUTBSRX 20,77
; 0000 02AC                                 }
; 0000 02AD 
; 0000 02AE                               switch(BP)
_0x87:
	MOV  R30,R17
	LDI  R31,0
; 0000 02AF                                 {
; 0000 02B0                                      case FlecheH_I2C: if (j_n > 0) j_n--; else j_n = (sizeof(TableInfos)/17)-1;  break;     // touche [flche bas]
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x8D
	CPI  R20,1
	BRLO _0x8E
	SUBI R20,1
	RJMP _0x8F
_0x8E:
	LDI  R20,LOW(7)
_0x8F:
	RJMP _0x8C
; 0000 02B1                                      case FlecheB_I2C: if (j_n < ((sizeof(TableInfos)/17)-1)) j_n++; else j_n = 0;  break;   // touche [flche haut]
_0x8D:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x90
	CPI  R20,7
	BRSH _0x91
	SUBI R20,-1
	RJMP _0x92
_0x91:
	LDI  R20,LOW(0)
_0x92:
	RJMP _0x8C
; 0000 02B2                                      case ECHAP_I2C: Menu = Menu_Infos; break;                      // touche [Echap]
_0x90:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x94
	LDI  R30,LOW(3)
	RJMP _0x143
; 0000 02B3                                      default: Menu = Menu_Affiche_Infos;
_0x94:
	LDI  R30,LOW(13)
_0x143:
	STS  _Menu,R30
; 0000 02B4                                 }
_0x8C:
; 0000 02B5 
; 0000 02B6                               Menu_1 = Menu_Affiche_Infos;
	LDI  R30,LOW(13)
	RJMP _0x137
; 0000 02B7 
; 0000 02B8        break;
; 0000 02B9 // ---------------------------------------------------------------------------------------------------------------------------------
; 0000 02BA // Fin des affichages
; 0000 02BB //==================================================================================================================================
; 0000 02BC // Dbut des tests et rglages avant le dpart
; 0000 02BD //==================================================================================================================================
; 0000 02BE // Rglage des coefficients PWM sauvegards en EEPROM
; 0000 02BF // ---------------------------------------------------------------------------------------------------------------------------------
; 0000 02C0         case Reglage_PWM :  if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
_0x86:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x95
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x97
	LDD  R30,Y+21
	LDD  R26,Y+20
	CP   R30,R26
	BRNE _0x97
	RJMP _0x96
_0x97:
; 0000 02C1                             {
; 0000 02C2                                 if (fmod(i_n,2)==0) // si i_n pair
	__GETW1SX 69
	CALL __CWD1
	CALL __CDF1
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	CALL _fmod
	CALL __CPD10
	BRNE _0x99
; 0000 02C3                                 {
; 0000 02C4                                     sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__GETW2SX 71
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	CALL __MULW12U
	SUBI R30,LOW(-_Tab_Aff_Reg*2)
	SBCI R31,HIGH(-_Tab_Aff_Reg*2)
	RJMP _0x144
; 0000 02C5                                     itoa(rcycl,pourcentage0);
; 0000 02C6                                     strcat(display_buffer_ligne0,pourcentage0);
; 0000 02C7                                 }
; 0000 02C8                                 else  // si i_n impair
_0x99:
; 0000 02C9                                 {
; 0000 02CA                                     sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__GETW2SX 71
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(24)
	LDI  R27,HIGH(24)
	CALL __MULW12U
	SUBI R30,LOW(-_Tab_Aff_Reg*2)
	SBCI R31,HIGH(-_Tab_Aff_Reg*2)
	ADIW R30,12
_0x144:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02CB                                     itoa(rcycl,pourcentage0);
	LDD  R30,Y+21
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 02CC                                     strcat(display_buffer_ligne0,pourcentage0);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 02CD                                 }
; 0000 02CE                                 sprintf(display_buffer_ligne1,"ENTR>Memo [ECH]");
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,221
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02CF                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 02D0                                 lcd_gotoxy(15,0); lcd_putchar('+');
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(43)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 02D1                                 lcd_gotoxy(15,1); lcd_putchar('-');
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(45)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 02D2                                 rcycl_1 = rcycl; // Notifie que l'affichage a chang
	LDD  R30,Y+21
	STD  Y+20,R30
; 0000 02D3                             }
; 0000 02D4 
; 0000 02D5                             switch(BP)
_0x96:
	MOV  R30,R17
	LDI  R31,0
; 0000 02D6                             {   // Rglage du rapport cyclique par pas de 5%
; 0000 02D7                                 case MOINS_I2C: if (rcycl > 5) rcycl = rcycl-5; else rcycl = 0; break; // touche [-]
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x9E
	LDD  R26,Y+21
	CPI  R26,LOW(0x6)
	BRLO _0x9F
	LDD  R30,Y+21
	LDI  R31,0
	SBIW R30,5
	RJMP _0x145
_0x9F:
	LDI  R30,LOW(0)
_0x145:
	STD  Y+21,R30
	RJMP _0x9D
; 0000 02D8                                 case PLUS_I2C:  if (rcycl < 100) rcycl = rcycl+5; else rcycl = 100; break; // touche [+]
_0x9E:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xA1
	LDD  R26,Y+21
	CPI  R26,LOW(0x64)
	BRSH _0xA2
	LDD  R30,Y+21
	SUBI R30,-LOW(5)
	RJMP _0x146
_0xA2:
	LDI  R30,LOW(100)
_0x146:
	STD  Y+21,R30
	RJMP _0x9D
; 0000 02D9                                 case ECHAP_I2C: Menu = Affiche_Reglages;  break; // touche [Echap]
_0xA1:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0xA4
	LDI  R30,LOW(14)
	RJMP _0x147
; 0000 02DA                                 case ENTR_I2C:  if (fmod(i_n,2)==0)             // si i_n pair touche [Entr]
_0xA4:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0xA8
	__GETW1SX 69
	CALL __CWD1
	CALL __CDF1
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	CALL _fmod
	CALL __CPD10
	BRNE _0xA6
; 0000 02DB                                                     PWM_EEPROM[i_n/2][0]=rcycl;
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RJMP _0x148
; 0000 02DC                                                 else                            // si i_n impair
_0xA6:
; 0000 02DD                                                     PWM_EEPROM[i_n/2][1]=rcycl;
	__GETW2SX 69
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
_0x148:
	LDD  R30,Y+21
	CALL __EEPROMWRB
; 0000 02DE 
; 0000 02DF                                                 Menu = Affiche_Reglages;
	LDI  R30,LOW(14)
	RJMP _0x147
; 0000 02E0                                 break;
; 0000 02E1                                 default: Menu = Reglage_PWM;
_0xA8:
	LDI  R30,LOW(7)
_0x147:
	STS  _Menu,R30
; 0000 02E2                             }
_0x9D:
; 0000 02E3 
; 0000 02E4                             Menu_1 = Reglage_PWM;
	LDI  R30,LOW(7)
	RJMP _0x137
; 0000 02E5        break;
; 0000 02E6 // -----------------------------------------------------------------------------------------------------------
; 0000 02E7 // Commande manuelle des servos 1 et 2
; 0000 02E8 // -----------------------------------------------------------------------------------------------------------
; 0000 02E9       case Cde_Servo : if ((Menu_1 != Menu) || (NumServo != NumServo_1)|| (Aff_Cde_Servo != Aff_Cde_Servo_1))
_0x95:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xA9
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xAB
	__GETB1SX 75
	__GETB2SX 76
	CP   R30,R26
	BRNE _0xAB
	__GETB1SX 73
	__GETB2SX 74
	CP   R30,R26
	BRNE _0xAB
	RJMP _0xAA
_0xAB:
; 0000 02EA                         {
; 0000 02EB                             sprintf(display_buffer_ligne0,"Cde Servo_%-u= %-u   ",NumServo,Aff_Cde_Servo);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,237
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 80
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETB1SX 82
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 02EC                             sprintf(display_buffer_ligne1,"[+] [-] [Echp]  ");
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,259
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02ED                             Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 02EE                             Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 02EF                             NumServo_1 = NumServo; // Notifie que l'affichage a chang
	__GETB1SX 76
	__PUTB1SX 75
; 0000 02F0                             Aff_Cde_Servo_1 = Aff_Cde_Servo;
	__GETB1SX 74
	__PUTB1SX 73
; 0000 02F1                         }
; 0000 02F2 
; 0000 02F3                        switch(BP)
_0xAA:
	MOV  R30,R17
	LDI  R31,0
; 0000 02F4                         {
; 0000 02F5                             case MOINS_I2C:                                     // touche [-]
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xB0
; 0000 02F6                                     if (NumServo==1) {CDE_SERVO1 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
	__GETB2SX 76
	CPI  R26,LOW(0x1)
	BRNE _0xB1
	CBI  0x12,6
	LDI  R30,0
	SBIC 0x10,6
	LDI  R30,1
	__PUTB1SX 74
; 0000 02F7                                     if (NumServo==2) {CDE_SERVO2 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
_0xB1:
	__GETB2SX 76
	CPI  R26,LOW(0x2)
	BRNE _0xB4
	CBI  0x12,7
	LDI  R30,0
	SBIC 0x10,7
	LDI  R30,1
	__PUTB1SX 74
; 0000 02F8                             break;
_0xB4:
	RJMP _0xAF
; 0000 02F9 
; 0000 02FA                             case PLUS_I2C:                                      // touche [+]
_0xB0:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xB7
; 0000 02FB                                     if (NumServo==1) {CDE_SERVO1 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
	__GETB2SX 76
	CPI  R26,LOW(0x1)
	BRNE _0xB8
	SBI  0x12,6
	LDI  R30,0
	SBIC 0x10,6
	LDI  R30,1
	__PUTB1SX 74
; 0000 02FC                                     if (NumServo==2) {CDE_SERVO2 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
_0xB8:
	__GETB2SX 76
	CPI  R26,LOW(0x2)
	BRNE _0xBB
	SBI  0x12,7
	LDI  R30,0
	SBIC 0x10,7
	LDI  R30,1
	__PUTB1SX 74
; 0000 02FD                             break;
_0xBB:
	RJMP _0xAF
; 0000 02FE 
; 0000 02FF                             case ECHAP_I2C: CDE_SERVO1 = 0; CDE_SERVO2 = 0;     // touche [Echap]
_0xB7:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0xBE
	CBI  0x12,6
	CBI  0x12,7
; 0000 0300                                             Menu = Menu_Test_Servos;
	LDI  R30,LOW(4)
	RJMP _0x149
; 0000 0301                             break;
; 0000 0302 
; 0000 0303                             case FlecheB_I2C:   if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
_0xBE:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0xC3
	__GETB2SX 76
	CPI  R26,LOW(0x1)
	BRNE _0xC4
	LDI  R30,LOW(2)
	__PUTB1SX 76
	LDI  R30,0
	SBIC 0x10,7
	LDI  R30,1
	RJMP _0x14A
; 0000 0304                                                     else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
_0xC4:
	__GETB2SX 76
	CPI  R26,LOW(0x2)
	BRNE _0xC6
	LDI  R30,LOW(1)
	__PUTB1SX 76
	LDI  R30,0
	SBIC 0x10,6
	LDI  R30,1
_0x14A:
	__PUTB1SX 74
; 0000 0305                             break;
_0xC6:
	RJMP _0xAF
; 0000 0306 
; 0000 0307                             case FlecheH_I2C:   if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
_0xC3:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xCB
	__GETB2SX 76
	CPI  R26,LOW(0x1)
	BRNE _0xC8
	LDI  R30,LOW(2)
	__PUTB1SX 76
	LDI  R30,0
	SBIC 0x10,7
	LDI  R30,1
	RJMP _0x14B
; 0000 0308                                                     else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
_0xC8:
	__GETB2SX 76
	CPI  R26,LOW(0x2)
	BRNE _0xCA
	LDI  R30,LOW(1)
	__PUTB1SX 76
	LDI  R30,0
	SBIC 0x10,6
	LDI  R30,1
_0x14B:
	__PUTB1SX 74
; 0000 0309                             break;
_0xCA:
	RJMP _0xAF
; 0000 030A 
; 0000 030B                             default: Menu = Cde_Servo;
_0xCB:
	LDI  R30,LOW(15)
_0x149:
	STS  _Menu,R30
; 0000 030C                         }
_0xAF:
; 0000 030D 
; 0000 030E                         Menu_1 = Cde_Servo;
	LDI  R30,LOW(15)
	RJMP _0x137
; 0000 030F       break;
; 0000 0310 // -----------------------------------------------------------------------------------------------------------
; 0000 0311 // Commande manuelle des moteurs D et G
; 0000 0312 // -----------------------------------------------------------------------------------------------------------
; 0000 0313       case Cde_Moteurs :  if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
_0xA9:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xCC
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xCE
	LDD  R30,Y+21
	LDD  R26,Y+20
	CP   R30,R26
	BREQ _0xCD
_0xCE:
; 0000 0314                             {
; 0000 0315                                 sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,276
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+25
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 0316                                 sprintf(display_buffer_ligne1,"[+] [-] [Echap] ");
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,294
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0317                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0318                                 rcycl_1 = rcycl;
	LDD  R30,Y+21
	STD  Y+20,R30
; 0000 0319                             }
; 0000 031A 
; 0000 031B                             switch(BP)
_0xCD:
	MOV  R30,R17
	LDI  R31,0
; 0000 031C                             {
; 0000 031D                                 case MOINS_I2C: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break; // touche [-]
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xD3
	LDD  R26,Y+21
	CPI  R26,LOW(0xB)
	BRLO _0xD4
	LDD  R30,Y+21
	LDI  R31,0
	SBIW R30,10
	RJMP _0x14C
_0xD4:
	LDI  R30,LOW(0)
_0x14C:
	STD  Y+21,R30
	RJMP _0xD2
; 0000 031E                                 case PLUS_I2C: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break; // touche [+]
_0xD3:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xD6
	LDD  R26,Y+21
	CPI  R26,LOW(0x5A)
	BRSH _0xD7
	LDD  R30,Y+21
	SUBI R30,-LOW(10)
	RJMP _0x14D
_0xD7:
	LDI  R30,LOW(100)
_0x14D:
	STD  Y+21,R30
	RJMP _0xD2
; 0000 031F                                 case ECHAP_I2C : rcycl = 0; Menu = Menu_Test_Moteurs; break; // touche [Echap]
_0xD6:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0xDA
	LDI  R30,LOW(0)
	STD  Y+21,R30
	LDI  R30,LOW(5)
	RJMP _0x14E
; 0000 0320                                 default: Menu = Cde_Moteurs;
_0xDA:
	LDI  R30,LOW(6)
_0x14E:
	STS  _Menu,R30
; 0000 0321                             }
_0xD2:
; 0000 0322 
; 0000 0323                             // Transfert des rapports cycliques vers les registres
; 0000 0324                             OCR1AL=alpha[rcycl/10];
	LDD  R26,Y+21
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R26,R28
	ADIW R26,9
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	OUT  0x2A,R30
; 0000 0325                             OCR1BL=alpha[rcycl/10];
	LDD  R26,Y+21
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R26,R28
	ADIW R26,9
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	OUT  0x28,R30
; 0000 0326                             Menu_1 = Cde_Moteurs ;
	LDI  R30,LOW(6)
	RJMP _0x137
; 0000 0327      break;
; 0000 0328 // -----------------------------------------------------------------------------------------------------------
; 0000 0329 // Visualisation de la position du robot par rapport  la ligne sur l'afficheur
; 0000 032A // -----------------------------------------------------------------------------------------------------------
; 0000 032B      case Visu_Position :   // ------------------------------------------------------------------------------------
_0xCC:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xDB
; 0000 032C                             // Dbut FS11 : Fonction acqurir la position du robot par rapport  la ligne
; 0000 032D                             // ------------------------------------------------------------------------------------
; 0000 032E                                 #if  POSITIONCONNECTEUR == CONNECTEURAR
; 0000 032F                                 PositionRobotSVL = CalculerValeurCapteurLigne();
	CALL _CalculerValeurCapteurLigne
	__PUTB1SX 66
; 0000 0330                                 #else
; 0000 0331                                 PositionRobotSVL = CalculerValeurCapteurLigne();
; 0000 0332                                 PositionRobotSVL = AdapterValeurCapteurLigneSiConnecteurAV(PositionRobotSVL);
; 0000 0333                                 #endif
; 0000 0334                                 delay_us(1500);
	__DELAY_USW 3000
; 0000 0335                             // ------------------------------------------------------------------------------------
; 0000 0336                             // Fin FS11
; 0000 0337                             // ------------------------------------------------------------------------------------
; 0000 0338                             // Dbut FS13 : Fonction Visualiser (Visualisation de la position des capteurs sur la ligne)
; 0000 0339                             // ------------------------------------------------------------------------------------
; 0000 033A                                 if ((Menu_1 != Menu) || (PositionRobotSVL != PositionRobotSVL_1))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xDD
	__GETB1SX 65
	__GETB2SX 66
	CP   R30,R26
	BRNE _0xDD
	RJMP _0xDC
_0xDD:
; 0000 033B                                  {
; 0000 033C                                     switch (PositionRobotSVL)
	__GETB1SX 66
	LDI  R31,0
; 0000 033D                                     {
; 0000 033E                                     case POS_HORS_LIGNE:        sprintf(display_buffer_ligne0,"Pos = Hors ligne"); // Hors ligne
	SBIW R30,0
	BRNE _0xE2
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,311
	RJMP _0x14F
; 0000 033F                                     break;
; 0000 0340                                     case AR_GAUCHE_OU_AV_DROITE_3PLUS:      sprintf(display_buffer_ligne0,"Pos = Gauche 3+ "); break; // Gauche3+
_0xE2:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0xE3
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,328
	RJMP _0x14F
; 0000 0341                                     case AR_GAUCHE_OU_AV_DROITE_2PLUS:      sprintf(display_buffer_ligne0,"Pos = Gauche 2+ "); break; // Gauche2+
_0xE3:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0xE4
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,345
	RJMP _0x14F
; 0000 0342                                     case POS_CENTRE_1:                          sprintf(display_buffer_ligne0,"Pos = Centre_1  "); break; // Centre1 non visualis
_0xE4:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0xE5
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,362
	RJMP _0x14F
; 0000 0343                                     case AR_GAUCHE_OU_AV_DROITE_PLUS:       sprintf(display_buffer_ligne0,"Pos = Gauche +  "); break; // Gauche+
_0xE5:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0xE6
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,379
	RJMP _0x14F
; 0000 0344                                     case POS_CENTRE_3:                          sprintf(display_buffer_ligne0,"Pos = Centre_3  "); break; // Centre3
_0xE6:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0xE7
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,396
	RJMP _0x14F
; 0000 0345                                     case AR_GAUCHE_OU_AV_DROITE:            sprintf(display_buffer_ligne0,"Pos = Gauche    "); break; // Gauche
_0xE7:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0xE8
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,413
	RJMP _0x14F
; 0000 0346                                     case AR_DROITE_OU_AV_GAUCHE_3PLUS:      sprintf(display_buffer_ligne0,"Pos = Droite 3+ "); break; // Droite3+
_0xE8:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xE9
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,430
	RJMP _0x14F
; 0000 0347                                     case AR_DROITE_OU_AV_GAUCHE_2PLUS:      sprintf(display_buffer_ligne0,"Pos = Droite 2+ "); break; // Droite2+
_0xE9:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0xEA
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,447
	RJMP _0x14F
; 0000 0348                                     case AR_DROITE_OU_AV_GAUCHE_PLUS:       sprintf(display_buffer_ligne0,"Pos = Droite +  "); break; // Droite+
_0xEA:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0xEB
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,464
	RJMP _0x14F
; 0000 0349                                     case AR_DROITE_OU_AV_GAUCHE:            sprintf(display_buffer_ligne0,"Pos = Droite    "); break; // Droite
_0xEB:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0xEC
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,481
	RJMP _0x14F
; 0000 034A                                     case POS_CENTRE_5:                          sprintf(display_buffer_ligne0,"Pos = Centre_5  "); break; // Centre5
_0xEC:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0xEE
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,498
	RJMP _0x14F
; 0000 034B                                     default:                                sprintf(display_buffer_ligne0,"Pos = ?????     "); // Erreur mesure
_0xEE:
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,515
_0x14F:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 034C                                     }
; 0000 034D 
; 0000 034E                                     sprintf(display_buffer_ligne1,"[%-i]     [ECHAP]",PositionRobotSVL);
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,532
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 70
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 034F                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0350                                     PositionRobotSVL_1 = PositionRobotSVL;
	__GETB1SX 66
	__PUTB1SX 65
; 0000 0351                                  }
; 0000 0352                                 VisuPositionSurLED = AfficherPositionRobotSVL(PositionRobotSVL);
_0xDC:
	__GETB1SX 66
	ST   -Y,R30
	CALL _AfficherPositionRobotSVL
	__PUTB1SX 64
; 0000 0353                                 Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuPositionSurLED);  		// Ecriture sur les LED via le bus I2C
	LDI  R30,LOW(64)
	ST   -Y,R30
	__GETB1SX 65
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 0354 
; 0000 0355                                 if (BP == ECHAP_I2C) Menu = Menu_Test_Capteurs_Ligne; // touche [Echap]
	CPI  R17,128
	BRNE _0xEF
	LDI  R30,LOW(9)
	RJMP _0x150
; 0000 0356                                             else Menu = Visu_Position;
_0xEF:
	LDI  R30,LOW(16)
_0x150:
	STS  _Menu,R30
; 0000 0357 
; 0000 0358                                 Menu_1 = Visu_Position;
	LDI  R30,LOW(16)
	RJMP _0x137
; 0000 0359       break;
; 0000 035A // -----------------------------------------------------------------------------------------------------------
; 0000 035B // Test de dtection du capteur cible
; 0000 035C // -----------------------------------------------------------------------------------------------------------
; 0000 035D #if PARCOURS_ROBOT == AVEC_ARRET
; 0000 035E       case Visu_Cible:      GICR=0x40; // Activation INT0
; 0000 035F                             if ((Menu_1 != Menu)|| (Cible != Cible_1))
; 0000 0360                             {
; 0000 0361                             switch (Cible) // Cible passe  1 lorsque le robot est devant la cible
; 0000 0362                               {
; 0000 0363                                 case 0: sprintf(display_buffer_ligne0,"Regler pos capt.");
; 0000 0364                                 break;
; 0000 0365 
; 0000 0366                                 case 1: sprintf(display_buffer_ligne0,"Pos capteur Ok  ");
; 0000 0367                                         Cible = 0;
; 0000 0368                                 break;
; 0000 0369                               }
; 0000 036A 
; 0000 036B                               sprintf(display_buffer_ligne1,"         [ECHAP]");
; 0000 036C                               Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
; 0000 036D                               Cible_1 = Cible;
; 0000 036E                             }
; 0000 036F 
; 0000 0370                             if (BP == ECHAP_I2C)                     // touche [Echap]
; 0000 0371                             {
; 0000 0372                                  Menu = Menu_Test_Capteurs_Cible;
; 0000 0373                                  Active_Moteurs();  // Ractivation PWM (Dsactive dans l'INT0)
; 0000 0374                                  #asm("cli")
; 0000 0375                              }
; 0000 0376                             else Menu = Visu_Cible;
; 0000 0377 
; 0000 0378                             Menu_1 = Visu_Cible;
; 0000 0379       break;
; 0000 037A 
; 0000 037B #elif PARCOURS_ROBOT == SANS_ARRET
; 0000 037C       case Visu_Cible:      if (Menu_1 != Menu)
_0xDB:
	CPI  R30,LOW(0x11)
	LDI  R26,HIGH(0x11)
	CPC  R31,R26
	BRNE _0xF1
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0xF2
; 0000 037D                             {
; 0000 037E                                 sprintf(display_buffer_ligne0,"!Test desactive!");
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,550
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 037F                                 sprintf(display_buffer_ligne1,"Compil Avec_Arre");
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,567
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0380       			    	        Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0381       			    	    }
; 0000 0382       			    		if (BP == ECHAP_I2C) 					// touche [Echap]
_0xF2:
	CPI  R17,128
	BRNE _0xF3
; 0000 0383      							Menu = Menu_Test_Capteurs_Cible;
	LDI  R30,LOW(10)
	RJMP _0x151
; 0000 0384      			 	   		else Menu = Visu_Cible;
_0xF3:
	LDI  R30,LOW(17)
_0x151:
	STS  _Menu,R30
; 0000 0385 
; 0000 0386       					    Menu_1 = Visu_Cible;
	LDI  R30,LOW(17)
	RJMP _0x137
; 0000 0387       break;
; 0000 0388 #endif
; 0000 0389 // -----------------------------------------------------------------------------------------------------------
; 0000 038A // Envoi d'un code (11 bits) sur la liaison IBM
; 0000 038B // -----------------------------------------------------------------------------------------------------------
; 0000 038C       case Transm_IBM :  if ((Menu_1 != Menu) || (CodeIBM_1 != CodeIBM) || (AffQuartet_1 != AffQuartet))
_0xF1:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xF5
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xF7
	LD   R30,Y
	LDD  R26,Y+1
	CP   R30,R26
	BRNE _0xF7
	LDD  R30,Y+4
	LDD  R26,Y+5
	CP   R30,R26
	BREQ _0xF6
_0xF7:
; 0000 038D                             {
; 0000 038E                                 sprintf(display_buffer_ligne0,"Code = 0x%-x%-x [%-c]",MSByteIBM,LSByteIBM,AffQuartet);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,584
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+15
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0000 038F                                 sprintf(display_buffer_ligne1,"[+/-][SET][ECH] ");
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,606
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0390                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0391                                 Affiche_Fleche();
	CALL _Affiche_Fleche
; 0000 0392                                 CodeIBM_1 = CodeIBM; AffQuartet_1 = AffQuartet;
	LD   R30,Y
	STD  Y+1,R30
	LDD  R30,Y+4
	STD  Y+5,R30
; 0000 0393                             }
; 0000 0394 
; 0000 0395                             switch(BP)
_0xF6:
	MOV  R30,R17
	LDI  R31,0
; 0000 0396                             {
; 0000 0397                                 case FlecheH_I2C: QuartetIBM = 1;
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xFC
	LDI  R30,LOW(1)
	STD  Y+6,R30
; 0000 0398                                                   AffQuartet = 'M';   // Slection quartet de poids fort
	LDI  R30,LOW(77)
	STD  Y+4,R30
; 0000 0399                                 break;                                // de CodeIBM
	RJMP _0xFB
; 0000 039A                                 case FlecheB_I2C: QuartetIBM = 0;
_0xFC:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0xFD
	LDI  R30,LOW(0)
	STD  Y+6,R30
; 0000 039B                                                   AffQuartet = 'L';   // Slection quartet de poids faible
	LDI  R30,LOW(76)
	STD  Y+4,R30
; 0000 039C                                 break;                                // de CodeIBM
	RJMP _0xFB
; 0000 039D 
; 0000 039E                                 case MOINS_I2C: if (QuartetIBM == 1)      // touche [-]
_0xFD:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xFE
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0xFF
; 0000 039F                                                     {
; 0000 03A0                                                         if (MSByteIBM > 0) MSByteIBM--; else MSByteIBM = 0;
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	BRLO _0x100
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	RJMP _0x152
_0x100:
	LDI  R30,LOW(0)
_0x152:
	STD  Y+8,R30
; 0000 03A1                                                     }
; 0000 03A2                                                 else
	RJMP _0x102
_0xFF:
; 0000 03A3                                                     {
; 0000 03A4                                                         if (LSByteIBM > 0) LSByteIBM--; else LSByteIBM = 0;
	LDD  R26,Y+7
	CPI  R26,LOW(0x1)
	BRLO _0x103
	LDD  R30,Y+7
	SUBI R30,LOW(1)
	RJMP _0x153
_0x103:
	LDI  R30,LOW(0)
_0x153:
	STD  Y+7,R30
; 0000 03A5                                                     }
_0x102:
; 0000 03A6                                                 CodeIBM =  (MSByteIBM << 4) | LSByteIBM;
	LDD  R30,Y+8
	SWAP R30
	ANDI R30,0xF0
	LDD  R26,Y+7
	OR   R30,R26
	ST   Y,R30
; 0000 03A7                                 break;
	RJMP _0xFB
; 0000 03A8 
; 0000 03A9                                 case PLUS_I2C: if (QuartetIBM == 1)    // touche [+]
_0xFE:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x105
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0x106
; 0000 03AA                                                     {
; 0000 03AB                                                         if (MSByteIBM < 15) MSByteIBM++; else MSByteIBM = 15;
	LDD  R26,Y+8
	CPI  R26,LOW(0xF)
	BRSH _0x107
	LDD  R30,Y+8
	SUBI R30,-LOW(1)
	RJMP _0x154
_0x107:
	LDI  R30,LOW(15)
_0x154:
	STD  Y+8,R30
; 0000 03AC                                                     }
; 0000 03AD                                                 else
	RJMP _0x109
_0x106:
; 0000 03AE                                                     {
; 0000 03AF                                                         if (LSByteIBM < 15) LSByteIBM++; else LSByteIBM = 15;
	LDD  R26,Y+7
	CPI  R26,LOW(0xF)
	BRSH _0x10A
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	RJMP _0x155
_0x10A:
	LDI  R30,LOW(15)
_0x155:
	STD  Y+7,R30
; 0000 03B0                                                     }
_0x109:
; 0000 03B1                                                 CodeIBM =  (MSByteIBM << 4) | LSByteIBM;
	LDD  R30,Y+8
	SWAP R30
	ANDI R30,0xF0
	LDD  R26,Y+7
	OR   R30,R26
	ST   Y,R30
; 0000 03B2                                 break;
	RJMP _0xFB
; 0000 03B3 
; 0000 03B4                                 case ECHAP_I2C : CodeIBM = 0; LSByteIBM= 0; MSByteIBM = 0; // touche [Echap]
_0x105:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x10C
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+7,R30
	STD  Y+8,R30
; 0000 03B5                                                  Menu = Menu_Test_Transm_IBM;
	LDI  R30,LOW(11)
	RJMP _0x156
; 0000 03B6                                 break;
; 0000 03B7 
; 0000 03B8                                 // Transfert du code en respectant le protocole IBM
; 0000 03B9                                 case SET_I2C : IBMTransfertChar(CodeIBM);
_0x10C:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x10E
	LD   R30,Y
	ST   -Y,R30
	RCALL _IBMTransfertChar
; 0000 03BA                                 break;
	RJMP _0xFB
; 0000 03BB                                 default: Menu = Transm_IBM ;
_0x10E:
	LDI  R30,LOW(12)
_0x156:
	STS  _Menu,R30
; 0000 03BC                             }
_0xFB:
; 0000 03BD 
; 0000 03BE                             Menu_1 = Transm_IBM  ;
	LDI  R30,LOW(12)
	RJMP _0x137
; 0000 03BF      break;
; 0000 03C0 // -----------------------------------------------------------------------------------------------------------
; 0000 03C1 // Fin des tests et rglages avant le dpart
; 0000 03C2 // -----------------------------------------------------------------------------------------------------------
; 0000 03C3 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 03C4 // Activation d'un parcours  = Dpart !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 03C5 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 03C6 // -----------------------------------------------------------------------------------------------------------
; 0000 03C7       case Activation :    if ((Menu_1 != Menu) || (decompte != decompte_1))
_0xF5:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x19
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x111
	__GETB1SX 71
	__GETB2SX 72
	CP   R30,R26
	BREQ _0x110
_0x111:
; 0000 03C8                             {
; 0000 03C9                                 sprintf(display_buffer_ligne0,"Depart dans %-us",decompte);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,623
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 76
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 03CA                                 sprintf(display_buffer_ligne1,"[Ech]>Desactiver");
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,640
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 03CB                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 03CC                                 decompte_1 = decompte; // Notifie que l'affichage a chang
	__GETB1SX 72
	__PUTB1SX 71
; 0000 03CD                             }
; 0000 03CE 
; 0000 03CF                             if (BP==ECHAP_I2C)
_0x110:
	CPI  R17,128
	BRNE _0x113
; 0000 03D0                                 {                   // touche [Echap] pour sortir du dcompte
; 0000 03D1                                                    decompte=Attente_Avant_Depart; // Rglage tempo en tte de fichier
	LDI  R30,LOW(5)
	__PUTB1SX 72
; 0000 03D2                                                    Menu=Menu_Reglages;
	LDI  R30,LOW(0)
	STS  _Menu,R30
; 0000 03D3                                                    break;
	RJMP _0x19
; 0000 03D4                                 }
; 0000 03D5                             else if(decompte == 0)
_0x113:
	__GETB1SX 72
	CPI  R30,0
	BREQ PC+3
	JMP _0x115
; 0000 03D6                                     {
; 0000 03D7                                         /*============================================================================================================
; 0000 03D8                                         // INITIALISATIONS du mode RUN
; 0000 03D9                                         //------------------------------------------------------------------------------------------------------------
; 0000 03DA                                         // Initialisation du mode Run (travail lve) => Chargement de la table PWM[][] avec les paramtres sauvegards
; 0000 03DB                                         // en EEPROM
; 0000 03DC                                         // i, k: compteur ligne, j compteur colonne
; 0000 03DD                                         // PWM_EEPROM[11,2] contient %Rapports cycliques -->  TABLE_CALCUL_OCRIx[21][2] --> PWM[11][2]
; 0000 03DE                                         //----------------------------------------------------------------------------------------------------------*/
; 0000 03DF                                         for (i=0;i<11;i++)          // La valeur de i dpend du nombre de capteurs utiliss
	LDI  R19,LOW(0)
_0x117:
	CPI  R19,11
	BRLO PC+3
	JMP _0x118
; 0000 03E0                                         {
; 0000 03E1                                         for (j=0;j<2;j++)
	LDI  R18,LOW(0)
_0x11A:
	CPI  R18,2
	BRLO PC+3
	JMP _0x11B
; 0000 03E2                                             {
; 0000 03E3                                             for (k=0;k<21;k++)      // La valeur de k dpend du nombre de rglage PWM contenue dans la table
	LDI  R21,LOW(0)
_0x11D:
	CPI  R21,21
	BRLO PC+3
	JMP _0x11E
; 0000 03E4                                                 {				    // Table_Calcul_OCR1x situe dans le fichier RB_ELEVE.h
; 0000 03E5                                                 #if FS12 == SOLUTIONPROF
; 0000 03E6                                                 if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x_PROF[k][0])
	MOV  R30,R19
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R18
	ADC  R27,R30
	CALL __EEPROMRDB
	MOV  R0,R30
	MOV  R30,R21
	LDI  R26,LOW(_Table_Calcul_OCR1x_PROF*2)
	LDI  R27,HIGH(_Table_Calcul_OCR1x_PROF*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	CP   R30,R0
	BRNE _0x11F
; 0000 03E7                                                     {
; 0000 03E8 	                                                PWM[i][j] = Table_Calcul_OCR1x_PROF[k][1];
	MOV  R30,R19
	LDI  R26,LOW(_PWM)
	LDI  R27,HIGH(_PWM)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R21
	LDI  R26,LOW(_Table_Calcul_OCR1x_PROF*2)
	LDI  R27,HIGH(_Table_Calcul_OCR1x_PROF*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	LPM  R30,Z
	MOVW R26,R0
	ST   X,R30
; 0000 03E9 	                                                break;
	RJMP _0x11E
; 0000 03EA 	                                                }
; 0000 03EB                                                 #else
; 0000 03EC                                                 if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x[k][0])
; 0000 03ED                                                     {
; 0000 03EE 	                                                PWM[i][j] = Table_Calcul_OCR1x[k][1];
; 0000 03EF 	                                                break;
; 0000 03F0 	                                                }
; 0000 03F1                                                 #endif
; 0000 03F2                                                 }
_0x11F:
	SUBI R21,-1
	RJMP _0x11D
_0x11E:
; 0000 03F3                                             }
	SUBI R18,-1
	RJMP _0x11A
_0x11B:
; 0000 03F4                                         }
	SUBI R19,-1
	RJMP _0x117
_0x118:
; 0000 03F5                                         //------------------------------------------------------------------------------------------------------------
; 0000 03F6                                         // Global enable interrupts
; 0000 03F7                                         //------------------------------------------------------------------------------------------------------------
; 0000 03F8                                         #if PARCOURS_ROBOT == AVEC_ARRET
; 0000 03F9                                         #asm("sei")
; 0000 03FA                                         #endif
; 0000 03FB                                         //------------------------------------------------------------------------------------------------------------
; 0000 03FC                                         // Fin initialisations
; 0000 03FD                                         //============================================================================================================
; 0000 03FE                                         // Lien vers le travail Elve  : SOUS-PROGRAMME Mode_RUN()
; 0000 03FF                                         //------------------------------------------------------------------------------------------------------------
; 0000 0400                                         // Appel de la fonction Mode_Run <=> dplacement du robot
; 0000 0401                                         //------------------------------------------------------------------------------------------------------------
; 0000 0402                                         Mode_Run(); // dans fichier RB_ELEVE.c
	RCALL _Mode_Run
; 0000 0403                                         //------------------------------------------------------------------------------------------------------------
; 0000 0404                                     }
; 0000 0405                             delay_ms(1000); decompte--;
_0x115:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	MOVW R26,R28
	SUBI R26,LOW(-(72))
	SBCI R27,HIGH(-(72))
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
; 0000 0406                             Menu_1 = Activation;
	LDI  R30,LOW(8)
_0x137:
	STS  _Menu_1,R30
; 0000 0407       break;
; 0000 0408 
; 0000 0409   } // Fin du switch principal
_0x19:
; 0000 040A //============================================================================================================
; 0000 040B   Ecrire_Port_I2C_Soft(Add_LED_I2C,~Code_BP); // Visualisation de l'activation d'un BP sur les LED
	LDI  R30,LOW(64)
	ST   -Y,R30
	MOV  R30,R16
	COM  R30
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 040C //============================================================================================================
; 0000 040D  } // Fin du while(1)
	JMP  _0x14
; 0000 040E //============================================================================================================
; 0000 040F } // fin du main
_0x120:
	RJMP _0x120
;//============================================================================================================
;//============================================================================================================
;// Fonction en cours de test
;//============================================================================================================
;void IBMTransfertChar(unsigned char Valeur)
; 0000 0415 {
_IBMTransfertChar:
; 0000 0416     unsigned char i;
; 0000 0417     unsigned int TrameIBM, LSB;
; 0000 0418 
; 0000 0419     ClkIBM = 1;
	CALL __SAVELOCR6
;	Valeur -> Y+6
;	i -> R17
;	TrameIBM -> R18,R19
;	LSB -> R20,R21
	SBI  0x12,1
; 0000 041A     DataIBM = 1;
	SBI  0x12,0
; 0000 041B 
; 0000 041C     // Prparation de la trame de 11 bits (format IBM PS2)
; 0000 041D     TrameIBM = (int)Valeur;
	LDD  R18,Y+6
	CLR  R19
; 0000 041E     TrameIBM = (TrameIBM << 1) | 0b0000010000000000;
	MOVW R30,R18
	LSL  R30
	ROL  R31
	ORI  R31,HIGH(0x400)
	MOVW R18,R30
; 0000 041F 
; 0000 0420     // Srialisation de la trame de 11 bits
; 0000 0421     for (i=0;i<11;i++)
	LDI  R17,LOW(0)
_0x126:
	CPI  R17,11
	BRSH _0x127
; 0000 0422     {
; 0000 0423         LSB = TrameIBM & 0x0001;// LSB = Valeur & 0x0001;
	MOVW R30,R18
	ANDI R30,LOW(0x1)
	ANDI R31,HIGH(0x1)
	MOVW R20,R30
; 0000 0424         if (LSB == 0) DataIBM = 0; else DataIBM = 1; // Positionnement de la donne
	MOV  R0,R20
	OR   R0,R21
	BRNE _0x128
	CBI  0x12,0
	RJMP _0x12B
_0x128:
	SBI  0x12,0
; 0000 0425         delay_us(10);
_0x12B:
	__DELAY_USB 27
; 0000 0426         ClkIBM = 0;    // front descendant
	CBI  0x12,1
; 0000 0427         delay_us(10);
	__DELAY_USB 27
; 0000 0428         ClkIBM = 1;    // front montant
	SBI  0x12,1
; 0000 0429         TrameIBM =  TrameIBM >> 1;
	LSR  R19
	ROR  R18
; 0000 042A     }
	SUBI R17,-1
	RJMP _0x126
_0x127:
; 0000 042B 
; 0000 042C     ClkIBM = 1;
	SBI  0x12,1
; 0000 042D     DataIBM = 1;
	SBI  0x12,0
; 0000 042E }
	CALL __LOADLOCR6
	ADIW R28,7
	RET
;//============================================================================================================
;/*-----------------------------------------------------------------------
;Nom du fichier: RBELEVE.c
;Auteur: Philippe MARIANO
;
;Projet: PPE Robot suiveur de ligne
;Rle: Fichier source du programme "Elve"
;Cr le: 18/02/2010
;Dernire rvision le: 22/02/2011
;
;Cross compilateur utilis: CodeVisionAVR V2
;Composant cible : ATMEL 8 bits sur carte "Robot SISI"
;
;Remarque: Ce fichier est destin  un projet CVAVR utilisant la carte SISI
;Il doit tre plac dans le  rpertoire du projet
;------------------------------------------------------------------------*/
;//============================================================================================================
;//============================================================================================================
;// Bibliothques
;//============================================================================================================
;// Bibliothques CVAVR
;//------------------------------------------------------------------------------------------------------------
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;//------------------------------------------------------------------------------------------------------------
;// Bibliothques dveloppes pour la carte SISI et le projet PPE ROBOT SUIVEUR DE LIGNE
;//------------------------------------------------------------------------------------------------------------
;#include "RB220.h"          // Paramtrage de la programmation
;#include "RBELEVE.h"
;#include "SISI2SVL.h"       // Contient les fonctions: Lire_BP_I2C_Soft, Affiche_LCD, Arret_Moteurs,
;                            // Active_Moteurs, Affiche_Fleche, AcquerirPositionRobotSVL,
;                            // AfficherPositionRobotSVL
;#include "PCF8574.h"        // Contient les fonctions: Ecrire_Port_I2C_Soft, Lire_Port_I2C_Soft
;//============================================================================================================
;
;//============================================================================================================
;// Dclaration des constantes
;//============================================================================================================
;// EtatCommandeMoteur : diffrents tats possibles pour la commande des moteurs   (NE PAS MODIFIER)
;// -----------------------------------------------------------------------------------------------------------
;#if FS12 == SOLUTIONELEVE
;enum EtatCommandeMoteur EtatCdeMot = DEPART;
;#endif
;//------------------------------------------------------------------------------------------------------------
;
;// Table de transcodage %PWM --> valeur  placer dans OCR1x pour le contrle des moteurs
;//------------------------------------------------------------------------------------------------------------
;/* Pour info: Rapports cycliques alpha du signal de commande des moteurs       // A supprimer dans fichier lve
;//------------------------------------------------------------------------------------------------------------
;// ATTENTION, dans le cas prsent: OCR1x = 255*alpha
;//------------------------------------------------------------------------------------------------------------
;// 				OCR1x		 	alpha
;#define _0PC	 0		 		// 0%
;#define _5PC	 13       		// 5%
;#define _10PC	 25             // 10%
;#define _15PC	 38             // 15%
;#define _20PC    51		 		// 20%
;#define _25PC	 64             // 25%
;#define _30PC    76		 		// 30%
;#define _35PC	 89             // 35%
;#define _40PC    102		 	// 40%
;#define _45PC	 115            // 45%
;#define _50PC    128            // 50%
;#define _55PC	 140            // 55%
;#define _60PC    153            // 60%
;#define _65PC	 166            // 65%
;#define _70PC    179            // 70%
;#define _75PC	 191            // 75%
;#define _80PC    205            // 80%
;#define _85PC    219            // 85%
;#define _90PC    233            // 90%
;#define _100%	 253			// ~100%
;------------------------------------------------------------------------------------------------------------*/
;// A COMPLETER PAR ELEVE en fonction des rsultats de la fiche guide FG4 + les valeurs x5%  (1< x <9)
;// ----------------------------------------------------------------------------------------------------------
;#if FS12 == SOLUTIONELEVE
;const unsigned char Table_Calcul_OCR1x[21][2]={{0,0},{5,13},{10,25},{15,38},{20,51},{25,64},{30,76},
;{35,89},{40,102},{45,115},{50,128},{55,140},{60,153},{65,166},{70,179},{75,191},{80,205},{85,219},
;{90,233},{95,233},{100,253}};
;#endif
;//============================================================================================================
;//============================================================================================================
;
;
;//============================================================================================================
;//============================================================================================================
;// ****************************** SOUS-PROGRAMME SUIVI DE LA LIGNE (ELEVE) ***********************************
;//============================================================================================================
;//============================================================================================================
;// 	Nom : Mode_Run()    Action :  LE ROBOT EFFECTUE SON PARCOURS !
;//------------------------------------------------------------------------------------------------------------
;// !!!!!!!!!!!!!!!!!! Attention : on sort du menu Mode_Run par une coupure de l'alimentation !!!!!!!!!!!!!!!!!
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Commutateur ON/OFF sur OFF !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;//============================================================================================================
;void Mode_Run(void)
; 0001 005F {

	.CSEG
_Mode_Run:
; 0001 0060 //------------------------------------------------------------------------------------------------------------
; 0001 0061 // Variables locales  Mode_Run()
; 0001 0062 //------------------------------------------------------------------------------------------------------------
; 0001 0063 // type			nom						Commentaires
; 0001 0064 //------------------------------------------------------------------------------------------------------------
; 0001 0065 unsigned char i;                // Compteur de boucle
; 0001 0066 
; 0001 0067 unsigned char VisuPosition;		// Contient la valeur transmise aux LED pendant le dplacement du robot
; 0001 0068 unsigned char Cde_Del_IR;		// Permet de multiplexer la commande des LED de capteurs d'infrarouges
; 0001 0069 unsigned char PositionRobot;    // Contient le rsultat du calcul de la position du robot par rapport  la
; 0001 006A                                 // ligne
; 0001 006B #if PARCOURS_ROBOT == AVEC_ARRET
; 0001 006C unsigned int Phase_Arret = 50;	// Compteur de boucle : Autorise la mesure de la position du robot
; 0001 006D 								// pendant 200ms aprs l'arrt du robot devant la cible
; 0001 006E #endif
; 0001 006F //============================================================================================================
; 0001 0070 
; 0001 0071 //============================================================================================================
; 0001 0072 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! BOUCLE INFINIE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0001 0073 //------------------------------------------------------------------------------------------------------------
; 0001 0074 while (1)
	CALL __SAVELOCR4
;	i -> R17
;	VisuPosition -> R16
;	Cde_Del_IR -> R19
;	PositionRobot -> R18
_0x20003:
; 0001 0075     {// dbut Mode_Run()
; 0001 0076 //============================================================================================================
; 0001 0077 // 1 - DETECTION DE LA CIBLE
; 0001 0078 //------------------------------------------------------------------------------------------------------------
; 0001 0079 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0001 007A // ATTENTION : A dsactiver dans le fichier RBxxx.h en prcisant SANS_ARRET devant #define PARCOURS_ROBOT
; 0001 007B // si la carte capteur cible n'est pas monte sur le robot
; 0001 007C // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0001 007D //------------------------------------------------------------------------------------------------------------
; 0001 007E // Phase d'arrt devant la cible: Mesure de la position et volution du graphe "SUIVI DE LIGNE" pendant
; 0001 007F // [4.3*10E-3*Phase_Arret] puis lancement du sous-programme Prise_Balle()
; 0001 0080 //------------------------------------------------------------------------------------------------------------
; 0001 0081 #if PARCOURS_ROBOT == AVEC_ARRET
; 0001 0082        if (Cible == 1)          // Cible passe  1 lorsque le robot est devant la cible
; 0001 0083         {
; 0001 0084           if (Phase_Arret == 0)
; 0001 0085                 Gestion_Balle(); // Cible <- dans INT0
; 0001 0086                 else
; 0001 0087                   Phase_Arret--;
; 0001 0088         }
; 0001 0089 #endif
; 0001 008A //============================================================================================================
; 0001 008B 
; 0001 008C /*============================================================================================================
; 0001 008D // 2 - SUIVI DE LA LIGNE
; 0001 008E //============================================================================================================
; 0001 008F // Cycle FS11 -> FS13 -> FS12
; 0001 0090 //------------------------------------------------------------------------------------------------------------
; 0001 0091 // Dbut de FS11: "Calculer la position du robot par rapport  la ligne"
; 0001 0092 //------------------------------------------------------------------------------------------------------------
; 0001 0093 Rle: Calculer une valeur numrique permettant de slectioner la LED IR (metteur IR) devant mettre
; 0001 0094 un faisceau infrarouge et calculer la valeur numrique reprsentative de la position du robot par
; 0001 0095 rapport  la ligne.
; 0001 0096 //------------------------------------------------------------------------------------------------------------
; 0001 0097 Entre: 	ACO		 		bit    		Associ  la sortie du comparateur analogique (interne au C).
; 0001 0098 							   			Reprsentatif de la position d'un capteur IR par rapport  la ligne.
; 0001 0099                                         ACO = 1 si le capteur IR activ est sur la ligne sinon ACO = 0
; 0001 009A //------------------------------------------------------------------------------------------------------------
; 0001 009B Sorties:    Cde_Del_IR 		octet   	Permet de multiplexer la commande des LED IR.
; 0001 009C 										Comme Cde_Del_IR est transfre dans le port A, on donne ci-dessous le
; 0001 009D           								dtail des bits de commande des LED IR.
; 0001 009E 
; 0001 009F 					   					Emetteur IR connect  au bit      Remarque
; 0001 00A0 										----------------------------------------------------
; 0001 00A1 										E_D_IR		"           PA0     |   Emetteur IR droit
; 0001 00A2 										E_CD_IR     "           PA1     |   Emetteur IR centre droit
; 0001 00A3 										E_C_IR		"           PA2     |	Emetteur IR centre
; 0001 00A4 										E_CG_IR     "	        PA3	    |   Emetteur IR centre Gauche
; 0001 00A5 										E_G_IR 		"           PA4     |	Emetteur IR gauche
; 0001 00A6 
; 0001 00A7 			Position_Robot	octet 		Image de la position du robot par rapport  la ligne
; 0001 00A8 										(dtails dans RBELEVE.h)
; 0001 00A9 ------------------------------------------------------------------------------------------------------------*/
; 0001 00AA //------------------------------------------------------------------------------------------------------------
; 0001 00AB //------------------------------------------------------------------------------------------------------------
; 0001 00AC //Solution prof
; 0001 00AD //------------------------------------------------------------------------------------------------------------
; 0001 00AE #if FS11 == SOLUTIONPROF
; 0001 00AF       PositionRobot = CalculerValeurCapteurLigne();
	CALL _CalculerValeurCapteurLigne
	MOV  R18,R30
; 0001 00B0 #else
; 0001 00B1 //------------------------------------------------------------------------------------------------------------
; 0001 00B2 // Solution lve
; 0001 00B3 //------------------------------------------------------------------------------------------------------------
; 0001 00B4 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! REMPLACER les ??? CI-DESSOUS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0001 00B5 //------------------------------------------------------------------------------------------------------------
; 0001 00B6       PositionRobot = HORS_LIGNE; // Initialisation  0
; 0001 00B7       Cde_Del_IR = 1;
; 0001 00B8 
; 0001 00B9       for (i=0;i<5;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
; 0001 00BA        {
; 0001 00BB         CAPTEUR_IR = ~Cde_Del_IR;
; 0001 00BC       	delay_us(30);	// Activation d'un capteur  ajuster   (19s par dfaut)
; 0001 00BD         if (ACO == 1) PositionRobot = PositionRobot | Cde_Del_IR;
; 0001 00BE         CAPTEUR_IR = 0xFF;
; 0001 00BF         Cde_Del_IR = Cde_Del_IR << 1 ;
; 0001 00C0         delay_us(540);	//  ajuster   (540s par dfaut)
; 0001 00C1        }
; 0001 00C2 #endif
; 0001 00C3 //------------------------------------------------------------------------------------------------------------
; 0001 00C4 // Fin de FS11
; 0001 00C5 //------------------------------------------------------------------------------------------------------------
; 0001 00C6 
; 0001 00C7 /*------------------------------------------------------------------------------------------------------------
; 0001 00C8 // Dbut FS13 "Choisir la valeur  afficher sur les LED" (Visualiser la position du robot)
; 0001 00C9 //------------------------------------------------------------------------------------------------------------
; 0001 00CA Rle: Choisir la valeur numrique ncessaire  la commande des LED rouge pour que leur clairage soit
; 0001 00CB reprsentatif de la position du robot par rapport  la ligne noire.
; 0001 00CC //------------------------------------------------------------------------------------------------------------
; 0001 00CD Entre
; 0001 00CE Position_Robot:     octet 	    Reprsentatif de la position du robot. Les deux positions possibles pour
; 0001 00CF                                 le capteur "LIGNE" sont traites dans RBELEVE.h (Connecteur du capteur vers
; 0001 00D0                                 l'avant ou connecteur du capteur vers l'arrire).
; 0001 00D1 //------------------------------------------------------------------------------------------------------------
; 0001 00D2 Sortie
; 0001 00D3 VisuPosition:       octet  	    Reprsentatif des LED  clairer. Le bit 0 de VisuPosition commande la
; 0001 00D4 						        Led D0 de l'interface IHM etc. Les valeurs  placer dans VisuPosition sont dfinies
; 0001 00D5 						        dans le fichier RBELEVE.h
; 0001 00D6 ------------------------------------------------------------------------------------------------------------*/
; 0001 00D7 //------------------------------------------------------------------------------------------------------------
; 0001 00D8 //Solution prof
; 0001 00D9 //------------------------------------------------------------------------------------------------------------
; 0001 00DA #if FS13 == SOLUTIONPROF
; 0001 00DB 
; 0001 00DC #if  POSITIONCONNECTEUR == CONNECTEURAR
; 0001 00DD         VisuPosition = AfficherPositionRobotSVL(PositionRobot);
	ST   -Y,R18
	CALL _AfficherPositionRobotSVL
	MOV  R16,R30
; 0001 00DE 
; 0001 00DF #elif POSITIONCONNECTEUR == CONNECTEURAV
; 0001 00E0         PositionRobot = AdapterValeurCapteurLigneSiConnecteurAV(PositionRobot);
; 0001 00E1         VisuPosition = AfficherPositionRobotSVL(PositionRobot);
; 0001 00E2 #endif
; 0001 00E3 //------------------------------------------------------------------------------------------------------------
; 0001 00E4 // Solution lve
; 0001 00E5 //------------------------------------------------------------------------------------------------------------
; 0001 00E6 #else
; 0001 00E7 //------------------------------------------------------------------------------------------------------------
; 0001 00E8         switch (PositionRobot)
; 0001 00E9         {
; 0001 00EA //------------------------------------------------------------------------------------------------------------
; 0001 00EB // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! REMPLACER les ??? CI-DESSOUS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0001 00EC //------------------------------------------------------------------------------------------------------------
; 0001 00ED // 		    Position_Robot 			Modification de la commande des LED             Commentaires
; 0001 00EE //------------------------------------------------------------------------------------------------------------
; 0001 00EF 		    case HORS_LIGNE:  		VisuPosition = Visu_Hors_ligne; break;			// Hors ligne
; 0001 00F0    		    case GAUCHE_3PLUS:  	VisuPosition = Visu_GAUCHE_3PLUS; break;		// Gauche3+
; 0001 00F1   		    case GAUCHE_2PLUS:  	VisuPosition = Visu_GAUCHE_2PLUS; break;		// Gauche2+
; 0001 00F2    		    case CENTRE_1:     		VisuPosition = Visu_CENTRE_1; break;			// Centre1 non visualis
; 0001 00F3             case GAUCHE_PLUS:  		VisuPosition = Visu_GAUCHE_PLUS; break;			// Gauche+
; 0001 00F4             case CENTRE_3: 	   		VisuPosition = Visu_CENTRE_3; break;			// Centre3
; 0001 00F5             case GAUCHE: 			VisuPosition = Visu_GAUCHE; break;				// Gauche
; 0001 00F6             case DROITE_3PLUS: 		VisuPosition = Visu_DROITE_3PLUS; break;		// Droite3+
; 0001 00F7             case DROITE_2PLUS: 		VisuPosition = Visu_DROITE_2PLUS; break;		// Droite2+
; 0001 00F8             case DROITE_PLUS:  		VisuPosition = Visu_DROITE_PLUS; break;			// Droite+
; 0001 00F9             case DROITE: 	   		VisuPosition = Visu_DROITE; break;				// Droite
; 0001 00FA             case CENTRE_5: 			VisuPosition = Visu_CENTRE_5; break;			// Centre5
; 0001 00FB             default :				VisuPosition = 0b00011111; break;				// Visu_Erreur_mesure_ligne
; 0001 00FC         }
; 0001 00FD //------------------------------------------------------------------------------------------------------------
; 0001 00FE #endif
; 0001 00FF //------------------------------------------------------------------------------------------------------------
; 0001 0100         Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuPosition);  		// Ecriture sur les LED via le bus I2C
	LDI  R30,LOW(64)
	ST   -Y,R30
	ST   -Y,R16
	CALL _Ecrire_Port_I2C_Soft
; 0001 0101 //------------------------------------------------------------------------------------------------------------
; 0001 0102 // Fin de FS13
; 0001 0103 //------------------------------------------------------------------------------------------------------------
; 0001 0104 
; 0001 0105 
; 0001 0106 /*------------------------------------------------------------------------------------------------------------
; 0001 0107 // Dbut FS12: "Choisir les valeurs des rapports cycliques"	(Corriger la trajectoire du robot)
; 0001 0108 //------------------------------------------------------------------------------------------------------------
; 0001 0109 Rle: Choisir la valeur des rapports cycliques des signaux de commande des moteurs du robot en fonction de
; 0001 010A sa position par rapport  la ligne noire.
; 0001 010B //------------------------------------------------------------------------------------------------------------
; 0001 010C Entre:          Position_Robot           octet     (voir FS13)
; 0001 010D //------------------------------------------------------------------------------------------------------------
; 0001 010E Sorties:         CDE_MOTD                 octet		Correspond au registre (OCR1A). Rgle le rapport cyclique
; 0001 010F 													du signal de commande du moteur droit.
; 0001 0110 				 CDE_MOTG                 octet     Correspond au registre (OCR1B). Rgle le rapport cyclique
; 0001 0111 				 							 		du signal de commande du moteur gauche.
; 0001 0112 ------------------------------------------------------------------------------------------------------------*/
; 0001 0113 // Graphe d'tats-transitiond du suivi de ligne
; 0001 0114 //------------------------------------------------------------------------------------------------------------
; 0001 0115 //Solution prof
; 0001 0116 //------------------------------------------------------------------------------------------------------------
; 0001 0117 #if FS12 == SOLUTIONPROF
; 0001 0118         CorrigerTrajectoireRobotSVL(PositionRobot);
	ST   -Y,R18
	CALL _CorrigerTrajectoireRobotSVL
; 0001 0119 
; 0001 011A //------------------------------------------------------------------------------------------------------------
; 0001 011B // Solution lve
; 0001 011C //------------------------------------------------------------------------------------------------------------
; 0001 011D #else
; 0001 011E      switch (EtatCdeMot)
; 0001 011F        { // Dbut switch (EtatCdeMot)
; 0001 0120 // "Dpart"!
; 0001 0121         case DEPART: Arret_Moteurs();
; 0001 0122         		if ((PositionRobot == CENTRE_1)||(PositionRobot == CENTRE_3)||(PositionRobot == CENTRE_5))
; 0001 0123         		    {
; 0001 0124         		      Active_Moteurs();
; 0001 0125         		      EtatCdeMot = CDE_CENTRE;
; 0001 0126         		    }
; 0001 0127         		    else  EtatCdeMot = DEPART;
; 0001 0128         break;
; 0001 0129 //------------------------------------------------------------------------------------------------------------
; 0001 012A //------------------------------------------------------------------------------------------------------------
; 0001 012B // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!PARTIE A COMPLETER PAR ELEVE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0001 012C //------------------------------------------------------------------------------------------------------------
; 0001 012D // "Suivi de la ligne"
; 0001 012E         case CDE_CENTRE : CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
; 0001 012F                             if (PositionRobot == GAUCHE) EtatCdeMot = CDE_DROITE;
; 0001 0130                           	    else if (PositionRobot == DROITE) EtatCdeMot = CDE_GAUCHE;
; 0001 0131                           		    else if (PositionRobot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
; 0001 0132                           			    else EtatCdeMot = CDE_CENTRE;
; 0001 0133         break;
; 0001 0134 
; 0001 0135 
; 0001 0136         case CDE_DROITE:CDE_MOTG = PWM[1][0]; CDE_MOTD = PWM[1][1];
; 0001 0137                             if (PositionRobot == CENTRE_5 ) EtatCdeMot = CDE_CENTRE;
; 0001 0138                           	    else if (PositionRobot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
; 0001 0139                            		    else if (PositionRobot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
; 0001 013A                           			    else EtatCdeMot = CDE_DROITE;
; 0001 013B         break;
; 0001 013C 
; 0001 013D         case CDE_DROITE_PLUS:CDE_MOTG = PWM[2][0]; CDE_MOTD = PWM[2][1];
; 0001 013E         		            if (PositionRobot == GAUCHE) EtatCdeMot = CDE_DROITE;
; 0001 013F                                 else if (PositionRobot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS;
; 0001 0140                         		    else EtatCdeMot = CDE_DROITE_PLUS;
; 0001 0141         break;
; 0001 0142 
; 0001 0143         case CDE_DROITE_2PLUS: CDE_MOTG = PWM[3][0]; CDE_MOTD = PWM[3][1];
; 0001 0144         		            if (PositionRobot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
; 0001 0145         	       		        else if (PositionRobot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
; 0001 0146         			   		        else EtatCdeMot = CDE_DROITE_2PLUS;
; 0001 0147         break;
; 0001 0148 
; 0001 0149         case CDE_DROITE_3PLUS: CDE_MOTG = PWM[4][0]; CDE_MOTD = PWM[4][1];
; 0001 014A         		            if (PositionRobot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS;
; 0001 014B         	       		        else if (PositionRobot == HORS_LIGNE) EtatCdeMot = CDE_DROITE_4PLUS;
; 0001 014C         					        else EtatCdeMot = CDE_DROITE_3PLUS;
; 0001 014D         break;
; 0001 014E 
; 0001 014F         case CDE_DROITE_4PLUS : CDE_MOTG = PWM[5][0]; CDE_MOTD = PWM[5][1];
; 0001 0150         		            if (PositionRobot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
; 0001 0151         				        else EtatCdeMot = CDE_DROITE_4PLUS;
; 0001 0152         break;
; 0001 0153 
; 0001 0154         case CDE_GAUCHE: CDE_MOTG = PWM[6][0]; CDE_MOTD = PWM[6][1];
; 0001 0155                             if (PositionRobot == CENTRE_5) EtatCdeMot = CDE_CENTRE;
; 0001 0156                           	        else if (PositionRobot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
; 0001 0157                           		        else if (PositionRobot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
; 0001 0158                           			        else EtatCdeMot = CDE_GAUCHE;
; 0001 0159         break;
; 0001 015A 
; 0001 015B         case CDE_GAUCHE_PLUS: CDE_MOTG = PWM[7][0]; CDE_MOTD = PWM[7][1];
; 0001 015C                             if  (PositionRobot == DROITE) EtatCdeMot = CDE_GAUCHE;
; 0001 015D         	                    else if (PositionRobot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
; 0001 015E                                		else EtatCdeMot = CDE_GAUCHE_PLUS;
; 0001 015F         break;
; 0001 0160 
; 0001 0161         case CDE_GAUCHE_2PLUS: CDE_MOTG = PWM[8][0]; CDE_MOTD = PWM[8][1];
; 0001 0162         		            if (PositionRobot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
; 0001 0163         		                else if (PositionRobot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
; 0001 0164         					        else EtatCdeMot = CDE_GAUCHE_2PLUS;
; 0001 0165         break;
; 0001 0166 
; 0001 0167         case CDE_GAUCHE_3PLUS: CDE_MOTG = PWM[9][0]; CDE_MOTD = PWM[9][1];
; 0001 0168         		            if (PositionRobot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
; 0001 0169         	       		        else if (PositionRobot == HORS_LIGNE) EtatCdeMot = CDE_GAUCHE_4PLUS;
; 0001 016A         					        else EtatCdeMot = CDE_GAUCHE_3PLUS;
; 0001 016B         break;
; 0001 016C 
; 0001 016D         case CDE_GAUCHE_4PLUS: CDE_MOTG = PWM[10][0]; CDE_MOTD = PWM[10][1];
; 0001 016E         		            if (PositionRobot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
; 0001 016F         				        else EtatCdeMot = CDE_GAUCHE_4PLUS;
; 0001 0170         break;
; 0001 0171 
; 0001 0172         case CDE_COUPURE: CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
; 0001 0173                             switch(PositionRobot)
; 0001 0174                             {
; 0001 0175                                 case CENTRE_5:      EtatCdeMot = CDE_CENTRE; break;
; 0001 0176                                 case GAUCHE:        EtatCdeMot = CDE_DROITE; break;
; 0001 0177                                 case GAUCHE_PLUS:   EtatCdeMot = CDE_DROITE_PLUS; break;
; 0001 0178                                 case GAUCHE_2PLUS:  EtatCdeMot = CDE_DROITE_2PLUS; break;
; 0001 0179                                 case GAUCHE_3PLUS:  EtatCdeMot = CDE_DROITE_3PLUS; break;
; 0001 017A                                 case DROITE:        EtatCdeMot = CDE_GAUCHE ; break;
; 0001 017B                                 case DROITE_PLUS:   EtatCdeMot = CDE_GAUCHE_PLUS; break;
; 0001 017C                                 case DROITE_2PLUS:  EtatCdeMot = CDE_GAUCHE_2PLUS; break;
; 0001 017D                                 case DROITE_3PLUS:  EtatCdeMot = CDE_GAUCHE_3PLUS; break;
; 0001 017E                                 default:            EtatCdeMot = CDE_COUPURE; break;
; 0001 017F                             }
; 0001 0180 
; 0001 0181         break;
; 0001 0182 
; 0001 0183         // default : EtatCdeMot = CDE_CENTRE;
; 0001 0184         break;
; 0001 0185 
; 0001 0186 //------------------------------------------------------------------------------------------------------------
; 0001 0187 // Fin deFS12
; 0001 0188 //------------------------------------------------------------------------------------------------------------
; 0001 0189        }// Fin switch (EtatCdeMot)   */
; 0001 018A #endif
; 0001 018B //------------------------------------------------------------------------------------------------------------
; 0001 018C 
; 0001 018D // Fin Traiter
; 0001 018E //============================================================================================================
; 0001 018F        delay_us(2000); //  ajuster   (704s  par dfaut)
	__DELAY_USW 4000
; 0001 0190 //============================================================================================================
; 0001 0191     }
	RJMP _0x20003
; 0001 0192 } // fin Mode_Run();
;//============================================================================================================
;
;//============================================================================================================
;//============================================================================================================
;// *************************** SOUS-PROGRAMME GESTION DE LA BALLE ELEVE **************************************
;//============================================================================================================
;//============================================================================================================
;
;#if PARCOURS_ROBOT == AVEC_ARRET
;void Gestion_Balle(void)
;{
;// Dsactivation de la dtection de la cible
;Cible = 0;
;//---------------------------------------------------------
;// A complter par lve
;//---------------------------------------------------------
;//
;CDE_SERVO1 = 1; // Libration balle (Le bras se lve)
;delay_ms(300);
;CDE_SERVO1 = 0; // Arrt commande du bras
;CDE_SERVO2 = 1;  // Libration du marteau
;delay_ms(1500);  // Attente vacuation de la balle
;//---------------------------------------------------------
;// Marche Robot
;//---------------------------------------------------------
;Active_Moteurs();
;//---------------------------------------------------------
;}
;#endif
;
;//============================================================================================================
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2140007
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2140007:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret

	.DSEG

	.CSEG

	.CSEG
_strcat:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcat0:
    ld   r22,x+
    tst  r22
    brne strcat0
    sbiw r26,1
strcat1:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcat1
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	CALL __GETD1S0
	CALL __PUTPARD1
	CALL _ftrunc
	CALL __PUTD1S0
    brne __floor1
__floor0:
	CALL __GETD1S0
	JMP  _0x2140003
__floor1:
    brtc __floor0
	CALL __GETD1S0
	__GETD2N 0x3F800000
	CALL __SUBF12
	JMP  _0x2140003
_ceil:
	CALL __GETD1S0
	CALL __PUTPARD1
	CALL _ftrunc
	CALL __PUTD1S0
    brne __ceil1
__ceil0:
	CALL __GETD1S0
	RJMP _0x2140003
__ceil1:
    brts __ceil0
	CALL __GETD1S0
	__GETD2N 0x3F800000
	CALL __ADDF12
	RJMP _0x2140003
_fmod:
	SBIW R28,4
	__GETD1S 4
	CALL __CPD10
	BRNE _0x2060005
	__GETD1N 0x0
	RJMP _0x2140006
_0x2060005:
	__GETD1S 4
	__GETD2S 8
	CALL __DIVF21
	CALL __PUTD1S0
	CALL __CPD10
	BRNE _0x2060006
	__GETD1N 0x0
	RJMP _0x2140006
_0x2060006:
	CALL __GETD2S0
	CALL __CPD02
	BRGE _0x2060007
	CALL __GETD1S0
	CALL __PUTPARD1
	RCALL _floor
	RJMP _0x2060033
_0x2060007:
	CALL __GETD1S0
	CALL __PUTPARD1
	RCALL _ceil
_0x2060033:
	CALL __PUTD1S0
	__GETD2S 4
	CALL __MULF12
	__GETD2S 8
	CALL __SWAPD12
	CALL __SUBF12
_0x2140006:
	ADIW R28,12
	RET

	.CSEG
_Ecrire_Port_I2C_Soft:
	CALL _i2c_start
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
	JMP  _0x2140002
_Lire_Port_I2C_Soft:
	ST   -Y,R17
	CALL _i2c_start
	LDD  R30,Y+1
	ORI  R30,1
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R17,R30
	CALL _i2c_stop
	MOV  R30,R17
	LDD  R17,Y+0
	JMP  _0x2140002
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_Lire_BP_I2C_Soft:

	.DSEG

	.CSEG
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(66)
	ST   -Y,R30
	RCALL _Lire_Port_I2C_Soft
	MOV  R17,R30
	LDS  R30,_Etat_BP_I2C_S1050000000
	LDI  R31,0
	SBIW R30,0
	BRNE _0x20A0007
	CPI  R17,0
	BRNE _0x20A0008
	MOV  R16,R17
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(66)
	ST   -Y,R30
	RCALL _Lire_Port_I2C_Soft
	MOV  R17,R30
	CP   R17,R16
	BRNE _0x20A0009
	LDI  R30,LOW(1)
	STS  _Etat_BP_I2C_S1050000000,R30
	LDI  R30,LOW(0)
	RJMP _0x2140005
_0x20A0009:
	LDI  R30,LOW(255)
	RJMP _0x2140005
_0x20A0008:
	LDI  R30,LOW(255)
	RJMP _0x2140005
_0x20A0007:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x20A0006
	CPI  R17,0
	BREQ _0x20A000D
	MOV  R16,R17
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(66)
	ST   -Y,R30
	RCALL _Lire_Port_I2C_Soft
	MOV  R17,R30
	CP   R17,R16
	BRNE _0x20A000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_I2C_S1050000000,R30
	MOV  R30,R17
	RJMP _0x2140005
_0x20A000E:
	LDI  R30,LOW(0)
	RJMP _0x2140005
_0x20A000D:
	LDI  R30,LOW(0)
_0x20A0006:
_0x2140005:
	LD   R16,Y+
	LD   R17,Y+
	RET
_Affiche_LCD:
	CALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	RJMP _0x2140003
_Affiche_Fleche:
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_putchar
	RET
_Arret_Moteurs:
	LDI  R30,LOW(0)
	OUT  0x2F,R30
	OUT  0x2E,R30
	LDI  R30,LOW(48)
	OUT  0x12,R30
	RET
_Active_Moteurs:
	LDI  R30,LOW(241)
	OUT  0x2F,R30
	LDI  R30,LOW(1)
	OUT  0x2E,R30
	RET
_CalculerValeurCapteurLigne:
	CALL __SAVELOCR4
	LDI  R17,0
	LDI  R16,0
	LDI  R19,1
	LDI  R17,LOW(0)
_0x20A0012:
	CPI  R17,5
	BRSH _0x20A0013
	MOV  R30,R19
	COM  R30
	OUT  0x1B,R30
	__DELAY_USB 80
	SBIC 0x8,5
	OR   R16,R19
	LDI  R30,LOW(255)
	OUT  0x1B,R30
	LSL  R19
	__DELAY_USW 1080
	SUBI R17,-1
	RJMP _0x20A0012
_0x20A0013:
	MOV  R30,R16
_0x2140004:
	CALL __LOADLOCR4
_0x2140003:
	ADIW R28,4
	RET
_AfficherPositionRobotSVL:
	ST   -Y,R17
	LDI  R17,0
	LDD  R30,Y+1
	LDI  R31,0
	SBIW R30,0
	BRNE _0x20A0028
	LDI  R17,LOW(255)
	RJMP _0x20A0027
_0x20A0028:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x20A0029
	LDI  R17,LOW(255)
	RJMP _0x20A0027
_0x20A0029:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0x20A002A
	LDI  R17,LOW(255)
	RJMP _0x20A0027
_0x20A002A:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x20A002B
	LDI  R17,LOW(224)
	RJMP _0x20A0027
_0x20A002B:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x20A002C
	LDI  R17,LOW(225)
	RJMP _0x20A0027
_0x20A002C:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x20A002D
	LDI  R17,LOW(227)
	RJMP _0x20A0027
_0x20A002D:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x20A002E
	LDI  R17,LOW(231)
	RJMP _0x20A0027
_0x20A002E:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x20A002F
	LDI  R17,LOW(239)
	RJMP _0x20A0027
_0x20A002F:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x20A0030
	LDI  R17,LOW(240)
	RJMP _0x20A0027
_0x20A0030:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x20A0031
	LDI  R17,LOW(248)
	RJMP _0x20A0027
_0x20A0031:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x20A0032
	LDI  R17,LOW(252)
	RJMP _0x20A0027
_0x20A0032:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x20A0034
	LDI  R17,LOW(254)
	RJMP _0x20A0027
_0x20A0034:
	LDI  R17,LOW(31)
_0x20A0027:
	MOV  R30,R17
	LDD  R17,Y+0
	JMP  _0x2140002
_CorrigerTrajectoireRobotSVL:
	LDS  R30,_EtatCdeMoteur_S1050008000
	LDI  R31,0
	SBIW R30,0
	BRNE _0x20A0038
	RCALL _Arret_Moteurs
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BREQ _0x20A003A
	CPI  R26,LOW(0xE)
	BREQ _0x20A003A
	CPI  R26,LOW(0x1F)
	BRNE _0x20A0039
_0x20A003A:
	RCALL _Active_Moteurs
	LDI  R30,LOW(1)
	RJMP _0x20A0085
_0x20A0039:
	LDI  R30,LOW(0)
_0x20A0085:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A0038:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x20A003D
	LDS  R30,_PWM
	OUT  0x28,R30
	__GETB1MN _PWM,1
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x1E)
	BRNE _0x20A003E
	LDI  R30,LOW(4)
	RJMP _0x20A0086
_0x20A003E:
	LD   R26,Y
	CPI  R26,LOW(0xF)
	BRNE _0x20A0040
	LDI  R30,LOW(8)
	RJMP _0x20A0086
_0x20A0040:
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20A0042
	LDI  R30,LOW(14)
	RJMP _0x20A0086
_0x20A0042:
	LDI  R30,LOW(1)
_0x20A0086:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A003D:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x20A0044
	__GETB1MN _PWM,2
	OUT  0x28,R30
	__GETB1MN _PWM,3
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x1F)
	BRNE _0x20A0045
	LDI  R30,LOW(1)
	RJMP _0x20A0087
_0x20A0045:
	LD   R26,Y
	CPI  R26,LOW(0x1C)
	BRNE _0x20A0047
	LDI  R30,LOW(5)
	RJMP _0x20A0087
_0x20A0047:
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20A0049
	LDI  R30,LOW(14)
	RJMP _0x20A0087
_0x20A0049:
	LDI  R30,LOW(4)
_0x20A0087:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A0044:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x20A004B
	__GETB1MN _PWM,4
	OUT  0x28,R30
	__GETB1MN _PWM,5
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x1E)
	BRNE _0x20A004C
	LDI  R30,LOW(4)
	RJMP _0x20A0088
_0x20A004C:
	LD   R26,Y
	CPI  R26,LOW(0x18)
	BRNE _0x20A004E
	LDI  R30,LOW(6)
	RJMP _0x20A0088
_0x20A004E:
	LDI  R30,LOW(5)
_0x20A0088:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A004B:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x20A0050
	__GETB1MN _PWM,6
	OUT  0x28,R30
	__GETB1MN _PWM,7
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x1C)
	BRNE _0x20A0051
	LDI  R30,LOW(5)
	RJMP _0x20A0089
_0x20A0051:
	LD   R26,Y
	CPI  R26,LOW(0x10)
	BRNE _0x20A0053
	LDI  R30,LOW(7)
	RJMP _0x20A0089
_0x20A0053:
	LDI  R30,LOW(6)
_0x20A0089:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A0050:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x20A0055
	__GETB1MN _PWM,8
	OUT  0x28,R30
	__GETB1MN _PWM,9
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x18)
	BRNE _0x20A0056
	LDI  R30,LOW(6)
	RJMP _0x20A008A
_0x20A0056:
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20A0058
	LDI  R30,LOW(13)
	RJMP _0x20A008A
_0x20A0058:
	LDI  R30,LOW(7)
_0x20A008A:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A0055:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x20A005A
	__GETB1MN _PWM,10
	OUT  0x28,R30
	__GETB1MN _PWM,11
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x10)
	BRNE _0x20A005B
	LDI  R30,LOW(7)
	RJMP _0x20A008B
_0x20A005B:
	LDI  R30,LOW(13)
_0x20A008B:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A005A:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x20A005D
	__GETB1MN _PWM,12
	OUT  0x28,R30
	__GETB1MN _PWM,13
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x1F)
	BRNE _0x20A005E
	LDI  R30,LOW(1)
	RJMP _0x20A008C
_0x20A005E:
	LD   R26,Y
	CPI  R26,LOW(0x7)
	BRNE _0x20A0060
	LDI  R30,LOW(9)
	RJMP _0x20A008C
_0x20A0060:
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20A0062
	LDI  R30,LOW(14)
	RJMP _0x20A008C
_0x20A0062:
	LDI  R30,LOW(8)
_0x20A008C:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A005D:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x20A0064
	__GETB1MN _PWM,14
	OUT  0x28,R30
	__GETB1MN _PWM,15
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0xF)
	BRNE _0x20A0065
	LDI  R30,LOW(8)
	RJMP _0x20A008D
_0x20A0065:
	LD   R26,Y
	CPI  R26,LOW(0x3)
	BRNE _0x20A0067
	LDI  R30,LOW(10)
	RJMP _0x20A008D
_0x20A0067:
	LDI  R30,LOW(9)
_0x20A008D:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A0064:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x20A0069
	__GETB1MN _PWM,16
	OUT  0x28,R30
	__GETB1MN _PWM,17
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x7)
	BRNE _0x20A006A
	LDI  R30,LOW(9)
	RJMP _0x20A008E
_0x20A006A:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x20A006C
	LDI  R30,LOW(11)
	RJMP _0x20A008E
_0x20A006C:
	LDI  R30,LOW(10)
_0x20A008E:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A0069:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x20A006E
	__GETB1MN _PWM,18
	OUT  0x28,R30
	__GETB1MN _PWM,19
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x3)
	BRNE _0x20A006F
	LDI  R30,LOW(10)
	RJMP _0x20A008F
_0x20A006F:
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20A0071
	LDI  R30,LOW(12)
	RJMP _0x20A008F
_0x20A0071:
	LDI  R30,LOW(11)
_0x20A008F:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A006E:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x20A0073
	__GETB1MN _PWM,20
	OUT  0x28,R30
	__GETB1MN _PWM,21
	OUT  0x2A,R30
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x20A0074
	LDI  R30,LOW(11)
	RJMP _0x20A0090
_0x20A0074:
	LDI  R30,LOW(12)
_0x20A0090:
	STS  _EtatCdeMoteur_S1050008000,R30
	RJMP _0x20A0037
_0x20A0073:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x20A0037
	LDS  R30,_PWM
	OUT  0x28,R30
	__GETB1MN _PWM,1
	OUT  0x2A,R30
	LD   R30,Y
	LDI  R31,0
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x20A007A
	LDI  R30,LOW(1)
	RJMP _0x20A0091
_0x20A007A:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x20A007B
	LDI  R30,LOW(4)
	RJMP _0x20A0091
_0x20A007B:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x20A007C
	LDI  R30,LOW(5)
	RJMP _0x20A0091
_0x20A007C:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x20A007D
	LDI  R30,LOW(6)
	RJMP _0x20A0091
_0x20A007D:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x20A007E
	LDI  R30,LOW(7)
	RJMP _0x20A0091
_0x20A007E:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x20A007F
	LDI  R30,LOW(8)
	RJMP _0x20A0091
_0x20A007F:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x20A0080
	LDI  R30,LOW(9)
	RJMP _0x20A0091
_0x20A0080:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x20A0081
	LDI  R30,LOW(10)
	RJMP _0x20A0091
_0x20A0081:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x20A0083
	LDI  R30,LOW(11)
	RJMP _0x20A0091
_0x20A0083:
	LDI  R30,LOW(14)
_0x20A0091:
	STS  _EtatCdeMoteur_S1050008000,R30
_0x20A0037:
	JMP  _0x2140001
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G106:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G106
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G106
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G106
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G106
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G106:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G106
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G106
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G106
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G106
    sbi   __lcd_port,__lcd_rd     ;RD=1
	JMP  _0x2140001
_lcd_write_byte:
	CALL __lcd_ready
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL __lcd_write_data
	CALL __lcd_ready
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	RJMP _0x2140002
__lcd_read_nibble_G106:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G106
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G106
    andi  r30,0xf0
	RET
_lcd_read_byte0_G106:
	CALL __lcd_delay_G106
	RCALL __lcd_read_nibble_G106
    mov   r26,r30
	RCALL __lcd_read_nibble_G106
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G106)
	SBCI R31,HIGH(-__base_y_G106)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x2140002:
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x20C0004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x20C0004:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	JMP  _0x2140001
_lcd_puts:
	ST   -Y,R17
_0x20C0005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x20C0007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x20C0005
_0x20C0007:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G106:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G106:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G106
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2140001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G106,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G106,3
	RCALL __long_delay_G106
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL __lcd_write_data
	RCALL __long_delay_G106
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL __lcd_write_data
	RCALL __long_delay_G106
	LDI  R30,LOW(133)
	ST   -Y,R30
	CALL __lcd_write_data
	RCALL __long_delay_G106
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G106
	CPI  R30,LOW(0x5)
	BREQ _0x20C000B
	LDI  R30,LOW(0)
	RJMP _0x2140001
_0x20C000B:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x2140001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_PWM:
	.BYTE 0x16
_TexteMenuInfos:
	.BYTE 0x2
_TexteMenuTestServos:
	.BYTE 0x2
_TexteMenuTestMoteurs:
	.BYTE 0x2
_TexteMenuTestCaptLigne:
	.BYTE 0x2
_TexteMenuTestCaptCible:
	.BYTE 0x2
_TexteMenuTestTransmIBM:
	.BYTE 0x2
_Ligne1ChoixEntr:
	.BYTE 0x2
_Ligne1ChoixEchap:
	.BYTE 0x2

	.ESEG
_PWM_EEPROM:
	.BYTE 0x16

	.DSEG
_Menu:
	.BYTE 0x1
_Menu_1:
	.BYTE 0x1
__seed_G101:
	.BYTE 0x4
___rtc_status:
	.BYTE 0x1
_Etat_BP_I2C_S1050000000:
	.BYTE 0x1
_EtatCdeMoteur_S1050008000:
	.BYTE 0x1
__base_y_G106:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG

	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
